/* ixp425Timer.h - ixp425 processor timer library */

/* Copyright 2002 Wind River Systems, Inc. */

#include "copyright_wrs.h"

/*
modification history
--------------------
01c,09jul03,m_h  multiple callouts from auxClk
01b,27feb03,jb3  add C++ protection
01a,05jun02,jb  initial version...
*/

#ifndef INCixp425Timerh
#define INCixp425Timerh

#ifdef __cplusplus
extern "C" {
#endif

#define SYS_CLK_RATE_MIN (10)	  /* Minimum rate at which the system clock can run */
#define SYS_CLK_RATE_MAX (1000)	  /* 1000 ticks, Maximum rate at which the system clock can run */

                                          /* Do not actually have an auxiliary clock */
#define AUX_CLK_RATE_MIN (10)	  /* Minimum rate at which the auxiliary clock can run */
#define AUX_CLK_RATE_MAX (1000)	  /* 1000 ticks, Maximum rate at which the auxiliary clock can run */

/* auxClk functionality used within this BSP */
STATUS ixpAuxClkConnect (FUNCPTR routine, int arg);
void ixpAuxClkDisconnect (void);
void ixpAuxClkDisable (void);
void ixpAuxClkEnable (void);
int ixpAuxClkRateGet (void);
STATUS ixpAuxClkRateSet (int ticksPerSecond);


/* Assembly specific defs */
#ifndef _ASMLANGUAGE
#endif


#ifdef __cplusplus
}
#endif


#endif	/* INCixp425Timer.h */

