/***********************************************************************************/
/*                        M-Systems Confidential                                   */
/*           Copyright (C) M-Systems Flash Disk Pioneers Ltd. 1995-2003            */
/*                         All Rights Reserved                                     */
/***********************************************************************************/
/*                            NOTICE OF M-SYSTEMS OEM                              */
/*                           SOFTWARE LICENSE AGREEMENT                            */
/*                                                                                 */
/*      THE USE OF THIS SOFTWARE IS GOVERNED BY A SEPARATE LICENSE                 */
/*      AGREEMENT BETWEEN THE OEM AND M-SYSTEMS. REFER TO THAT AGREEMENT           */
/*      FOR THE SPECIFIC TERMS AND CONDITIONS OF USE,                              */
/*      OR CONTACT M-SYSTEMS FOR LICENSE ASSISTANCE:                               */
/*      E-MAIL = info@m-sys.com                                                    */
/***********************************************************************************/

/*
 * $Log:   V:/PVCSDB/DiskOnChip/archives/Testing/TrueFFS 6.3/Drop 2.5/3/common/flchkdef.h-arc  $
 * 
 *    Rev 1.31   Sep 26 2005 18:53:00   roneng
 * Update version number
 * 
 *    Rev 1.30   Sep 15 2005 14:36:34   roneng
 * Update version
 * 
 *    Rev 1.29   Sep 12 2005 19:20:58   roneng
 * Update version
 * 
 *    Rev 1.28   Sep 12 2005 13:07:12   roneng
 * Update version number
 * 
 *    Rev 1.27   Aug 21 2005 21:53:08   roneng
 * Update version number
 * 
 *    Rev 1.26   Aug 15 2005 16:22:08   roneng
 * FL_FIXED_MEDIA is always defined in BDK package
 * 
 *    Rev 1.25   Aug 14 2005 21:13:08   roneng
 * Change version number
 * 
 *    Rev 1.24   Aug 10 2005 19:15:02   roneng
 * Change version info
 * 
 *    Rev 1.23   Aug 03 2005 20:00:30   roneng
 * Update version index
 * 
 *    Rev 1.22   Jul 27 2005 18:08:40   roneng
 * Update version numer
 * 
 *    Rev 1.21   Jul 26 2005 11:00:10   roneng
 * Update version number
 * 
 *    Rev 1.20   Jul 19 2005 18:56:02   roneng
 * Update TFFS version to TFFS 6.3.1
 * 
 *    Rev 1.19   Jul 18 2005 19:15:34   oris
 * - Beta 2 RC5 EQA12
 * 
 *    Rev 1.18   Jul 17 2005 19:32:04   oris
 * -	Changed to BETA 2 RC5 EQA11
 * 
 *    Rev 1.17   Jul 14 2005 06:36:30   oris
 * Upgraded to Beta2 , RC5 EQA10
 * 
 *    Rev 1.16   Jul 11 2005 13:29:14   oris
 * Increament version to beta2 EQA9
 * 
 *    Rev 1.15   Jul 07 2005 08:20:44   OriS
 * Moved to Beta version
 * 
 *    Rev 1.14   Jul 06 2005 23:25:28   OriS
 * - Alpha 4 RC3 EQA6 -> RC4 EQA8 Alpha 4
 * - Limit number of binary partitions per socket to 3
 * 
 *    Rev 1.13   Jun 27 2005 22:20:20   OriS
 * Moved to RC3 eqa7
 * 
 *    Rev 1.12   Jun 17 2005 10:49:58   oris
 * Updated to EQA6
 * 
 *    Rev 1.11   Jun 15 2005 19:50:30   oris
 * Changed EQA version to 5
 * 
 *    Rev 1.10   Jun 14 2005 14:30:52   oris
 * Changed ro RC3 , ALPHA3, EQA4
 * 
 *    Rev 1.9   Jun 09 2005 15:49:30   oris
 * Moved RC version 2->3
 * 
 *    Rev 1.8   Jun 07 2005 06:18:38   OriS
 * - Documentation - Changed TrueFFS_EQA_Version = 3, TrueFFS_RC_Version = 2
 *   and TrueFFS_Alpha_Version = 2.
 * - Esthetics - Moved default SAFTL cache size to flbase.h
 * - Changed FL_PACKED_STRUCTS_SUPPORTED  compilation flag to be the default,
 *   and added a negative flag named FL_NO_PACKED_STRUCTS_SUPPORTED.
 * 
 *    Rev 1.7   May 19 2005 17:45:24   oris
 * - Changed version to EQA1 , ALPHA 2
 * - Added check for FS_CREATE_LOGICAL_PARTITIONS while FS_READ_ONLY is defined
 * - Changed error message that checks for FS_FORMAT_VOLUME while FS_READ_ONLY is defined.
 * 
 *    Rev 1.6   May 10 2005 11:54:52   oris
 * - Changed S/W version from EQA9 -> EQA0 and RC22
 * 
 *    Rev 1.5   May 02 2005 22:35:20   oris
 * - Bug fix: Made sure FS_READ_ONLY is always defined when FL_READ_ONLY is defined as file system wrire routines can not work without BD write routines.
 * 
 * - Cosmetics: Changed the prameters names of FL_TFFS_SLEEP default defintion.
 * 
 *    Rev 1.4   Apr 19 2005 02:55:06   oris
 * - Added new defaults:
 *   subFromFarPointer
 *   distanceBetweenFarPointers
 * - Removed unused compilation flags
 * - Changed from EQA3-EQA9
 * 
 *    Rev 1.3   Apr 05 2005 08:16:58   oris
 * Bug fix - FS_MAX_TL_PARTITION needs to be properly defined.
 * 
 *    Rev 1.2   Apr 04 2005 20:17:52   oris
 * - Changed EQA to number 3.
 * - compilation errors for Boot package.
 * - Added NULL entry after DEFAULT_FILE
 * 
 *    Rev 1.1   Mar 29 2005 16:58:18   oris
 * Changed EQA version to 2
 * 
 *    Rev 1.0   Mar 27 2005 09:27:28   oris
 * Initial revision.
 * 
 * 
 */

/************************/
/* TrueFFS source files */
/* -------------------- */
/************************/

/*****************************************************************************
* File Header                                                                *
* -----------                                                                *
* Name : flchkdef.h                                                          *
*                                                                            *
* Description : Sanity check for flcustom.h files.                           *
*                                                                            *
*****************************************************************************/

#ifndef _FL_CHK_DEFS_H_
#define _FL_CHK_DEFS_H_

#include "flcustom.h"
#include "flsystem.h"

/* Internal use to diffrentiate between 6.2.3 version that include new MTD or not */

/* #define FL_622_MTD_CODE */

#define FL_NEW_MAPSECTOR

#ifndef MTD_STANDALONE 

/* TrueFFS version
 *
 * Number written on the flash by INFTL format specifing the TrueFFS version
 * The media was formated with. the number bellow specifies version
 * 6.3.0.0
 */

#define TrueFFSVersion "6320"

/* Tracking number for TrueFFS configuration managment
 *
 * Number for configuration mangment of special purpose versions
 */

#define TrueFFS_EQA_Version   4
#define TrueFFS_RC_Version    0
#define TrueFFS_PATCH_Version 0
#define TrueFFS_Alpha_Version 0
#define TrueFFS_Beta_Version  0


/* Programmer type version 
 * 
 * This string is placed in the media header indicating the programmer
 * Name and version used to format the media 
 */

#ifndef FL_PROGRAMMER_NAME
#define FL_PROGRAMMER_NAME    "CORE"
#endif /* FL_PROGRAMMER_NAME */

#ifndef FL_PROGRAMMER_VERSION
#define FL_PROGRAMMER_VERSION "0000"
#endif /* FL_PROGRAMMER_VERSION */


/*******************************************/
/* Validity check and overlapping defines  */
/*******************************************/

#if !defined(FL_READ_ONLY) && !defined(FS_READ_ONLY) && defined(READ_ONLY)
#define FL_READ_ONLY
#define FS_READ_ONLY
#endif

/* The format option needs some internal defintions */
#if !defined(FL_FORMAT_VOLUME) && defined(FORMAT_VOLUME)
#define FL_FORMAT_VOLUME
#endif 

#if (defined(FL_FORMAT_VOLUME) && defined(FL_READ_ONLY))
#error "You can not define FL_READ_ONLY and FL_FORMAT_VOLUME at the same time"
#endif /* (defined(FL_FORMAT_VOLUME) && defined(FL_READ_ONLY)) */

#if (defined(FS_FORMAT_VOLUME) && defined(FS_READ_ONLY))
#error "You can not define FS_READ_ONLY and FS_FORMAT_VOLUME at the same time"
#endif /* (defined(FS_FORMAT_VOLUME) && defined(FS_READ_ONLY)) */

#if (defined(FS_CREATE_LOGICAL_PARTITIONS) && defined(FS_READ_ONLY))
#error "You can not define FS_READ_ONLY and FS_CREATE_LOGICAL_PARTITIONS"
#endif 

/* VERIFY_ERASED_SECTOR should always come together with FL_VERIFY_WRITE */

#if !defined(FL_VERIFY_WRITE) && defined(VERIFY_WRITE)
#define FL_VERIFY_WRITE
#endif

#if defined (FL_VERIFY_WRITE) && !defined (VERIFY_ERASED_SECTOR)
#define VERIFY_ERASED_SECTOR
#endif 
#if !defined (FL_VERIFY_WRITE) && defined (VERIFY_ERASED_SECTOR)
#define FL_VERIFY_WRITE
#endif 

/* In case FL_READ_ONLY is defined FS_READ_ONLY needs to be defined as well */
#ifdef FL_READ_ONLY
#ifndef FS_READ_ONLY
#define FS_RED_ONLY
#endif /* FS_READ_ONLY */
#endif /* FL_READ_ONLY */

/* Validity check for system files MACROES */
#ifndef FL_FOPEN
#define FL_FOPEN
#endif /* FL_FOPEN */
#ifndef FL_FCLOSE
#define FL_FCLOSE
#endif /* FL_FCLOSE */
#ifndef FL_FPRINTF
#define FL_FPRINTF
#endif /* FL_FPRINTF */


/* Number of file system - logical partitions
 *
 * Defines Maximum Number of logical partitons on a BDTL partition
 *
 * The actual number of partitions depends on the format placed on each device.
 */

#ifndef FS_MAX_LOGICAL_PARTITIONS
#define FS_MAX_LOGICAL_PARTITIONS	4	/* per TL partition. There is no hard limit */
#endif /* FS_MAX_LOGICAL_PARTITIONS */


/* Validity check of FL_VOLUMES and FL_SOCKETS parameters. */

#if !defined(FL_VOLUMES) && defined(VOLUMES)
#define FL_VOLUMES VOLUMES
#endif

#if !defined(FS_VOLUMES) && defined(FL_VOLUMES)
#define FS_VOLUMES FL_VOLUMES
#endif

#if !defined(FL_SOCKETS) && defined(SOCKETS)
#define FL_SOCKETS SOCKETS
#endif

#if !defined(FS_SOCKETS) && defined(FL_SOCKETS)
#define FS_SOCKETS FL_SOCKETS
#endif


#if !defined(FL_VOLUMES) && defined(FL_SOCKETS)
#define FL_VOLUMES FL_SOCKETS
#endif /* SOCKETS && ! VOLUMES */

#if !defined(FS_VOLUMES) && defined(FS_SOCKETS)
#define FS_VOLUMES FS_SOCKETS
#endif /* SOCKETS && ! VOLUMES */

#if !defined(FL_SOCKETS) && defined(FL_VOLUMES)
#define FL_SOCKETS FL_VOLUMES
#endif /* ! SOCKETS && VOLUMES */

#if !defined(FS_SOCKETS) && defined(FS_VOLUMES)
#define FS_SOCKETS FS_VOLUMES
#endif /* ! SOCKETS && VOLUMES */

#if (FL_SOCKETS > FL_VOLUMES) || (FS_SOCKETS > FS_VOLUMES)
#error "SOCKETS should not be bigger then VOLUMES"
#endif /* SOCKETS > VOLUMES */

#if !defined(FL_FIXED_MEDIA) && defined(FIXED_MEDIA)
#define FL_FIXED_MEDIA
#endif

/* The POLLING_INTERVAL definition is not really relevant to DiskOnChip
 * Starting from TrueFFS 6.1 it was removed from flcustom.h, but TrueFFS
 * still support this functionality.
 */
#ifndef POLLING_INTERVAL
#define POLLING_INTERVAL 0
#endif /* POLLING_INTERVAL */

/* TrueFFS 5.2 used the FL_QUICK_MOUNT_INFO_EXIST defintion. TrueFFS 6.1
 * uses simple FL_ON and FL_OFF instead.
 */

#define FL_QUICK_MOUNT_INFO_EXIST				FL_ON

/* Starting from TrueFFS 6.1 this flag does not reduce code and therfore was
 * added as a default.
 *
 */

#define FL_LOW_LEVEL

/* Some S/W modules like boot SDK do not need the read bad blocks tables routine.
 * However for TrueFFS these defintion is vital
 */

#define MTD_READ_BBT        /* Compile the read BBT routine code         */

#else  /* MTD_STANDALONE */

#ifndef FL_FIXED_MEDIA
#define FL_FIXED_MEDIA
#endif
#ifndef NO_READ_BBT_CODE

/* When compiled in the BDK mode, the read BBT code wiill be compiled unless
 * NO_READ_BBT_CODE was defined.
 */
#define MTD_READ_BBT        /* Compile the read BBT routine code         */

#endif /* NO_READ_BBT_CODE */

#define FL_SOCKETS            1 /* The only available number */
#define FIXED_MEDIA
#define DO_NOT_YIELD_CPU

#endif /* MTD_STANDALONE */


/* Number of translation layer partitions
 *
 * Defines Maximum Number of Traslation layer partitons on a physical device
 *
 * The actual number of partitions depends on the format placed on each device.
 */

#ifndef FL_MAX_TL_PARTITIONS
#define FL_MAX_TL_PARTITIONS 6
#endif /* FL_MAX_TL_PARTITIONS */

/* The Maximum number of partitions is limited to 8 due to SAFTL buffers  */
 
#if (FL_MAX_TL_PARTITIONS > 8)
#error "Can not define more then 8 partitions\r\n"
#endif /* (FL_MAX_TL_PARTITIONS > 8) */


/* Max Number of binary partitions */
#ifndef MAX_BINARY_PARTITIONS_PER_DRIVE
#define MAX_BINARY_PARTITIONS_PER_DRIVE 3  
#endif /* MAX_BINARY_PARTITIONS_PER_DRIVE */

/* There can not be more binary partition, then total supported partitions */
#if (MAX_BINARY_PARTITIONS_PER_DRIVE >= FL_MAX_TL_PARTITIONS)
#error "MAX_BINARY_PARTITIONS_PER_DRIVE must be smaller then FL_MAX_TL_PARTITIONS\r\n"
#endif /* (MAX_BINARY_PARTITIONS_PER_DRIVE >= FL_MAX_TL_PARTITIONS) */

/* Default file system TL partitions */
#if !defined(FS_MAX_TL_PARTITIONS) && defined(FL_MAX_TL_PARTITIONS)
#define FS_MAX_TL_PARTITIONS	FL_MAX_TL_PARTITIONS
#endif
 
/* The TLS and MTDS constants where changed in TrueFFS 6.2 to a
 * more generic name : FL_TLS and FL_MTDS
 */

#ifndef FL_TLS
#define FL_TLS TLS
#endif /* FL_TLS */
#ifndef FL_MTDS
#define FL_MTDS MTDS
#endif /* FL_MTDS */

/* Make sure that the CHARSIZE is well defined */ 
#ifndef CHARSIZE 
#define CHARSIZE        8  /*The default char size is 8*/ 
#endif 

/* Make sure flPack and flspread are well defined */
#if (CHARSIZE == 8)
#ifndef flspread
#define flspread(source,length)
#endif /* flspread */

#ifndef flpack
#define flpack(source,length)
#endif /* flpack */
#endif /* (CHARSIZE == 8) */

/* Make sure FL2BYTE is well defined */
#ifndef FL2BYTE
#if (CHARSIZE == 8)
#define FL2BYTE(var) ((FLByte)(var))
#else
#define FL2BYTE(var) ((FLByte)((var) & 0x00FF))
#endif /* (CHARSIZE == 8) */
#endif /* FL2BYTE */

/* These defines allow the user to add a prefix to the exported API */
#ifndef NAMING_CONVENTION
#define NAMING_CONVENTION
#endif /* NAMING_CONVENTION */
#ifndef TFFS_DLL_API
#define TFFS_DLL_API
#endif /* TFFS_DLL_API */

#ifndef FL_PACKED_STRUCTURES_BEFORE
#define FL_PACKED_STRUCTURES_BEFORE
#endif /* FL_PACKED_STRUCTURES_BEFORE */

#ifndef FL_PACKED_STRUCTURES_AFTER
#ifdef FL_PACKED_STRUCTURES
#define FL_PACKED_STRUCTURES_AFTER FL_PACKED_STRUCTURES
#else
#define FL_PACKED_STRUCTURES_AFTER
#endif /* FL_PACKED_STRUCTURES */
#endif /* FL_PACKED_STRUCTURES_AFTER */

/* Change default to assume compiler can pack structures */
#ifndef FL_NO_PACKED_STRUCTS_SUPPORTED
#define FL_PACKED_STRUCTS_SUPPORTED
#endif /* FL_NO_PACKED_STRUCTS_SUPPORTED */

/* Starting from TrueFFS version 6.x the ASSUMED_NFTL_UNIT_SIZE was changed to
 * FL_ASSUMED_MIN_UNIT_SIZE. 
 */

#ifndef FL_ASSUMED_MIN_UNIT_SIZE
#define FL_ASSUMED_MIN_UNIT_SIZE        ASSUMED_NFTL_UNIT_SIZE
#endif /* FL_ASSUMED_MIN_UNIT_SIZE */

/* Starting from TrueFFS version 6.x the MAX_VOLUME_MBYTES was changed to
 * FL_ASSUMED_MAX_VOLUME_MBYTES. 
 */

#ifndef FL_ASSUMED_MAX_VOLUME_MBYTES
#ifdef MAX_VOLUME_MBYTES
#define FL_ASSUMED_MAX_VOLUME_MBYTES        MAX_VOLUME_MBYTES
#else

/* TrueFFS sets the sector size according to this defintions. As a result customers 
   that do not customize this defintion will be limitted to a very small media (32MB)
   without even knowing it.
 */

#define FL_ASSUMED_MAX_VOLUME_MBYTES        64
#endif /* MAX_VOLUME_MBYTES */
#endif /* FL_ASSUMED_MAX_VOLUME_MBYTES */

/* When using static allocation , SAFTL may requires the number of sectors
 * in a logical unit. This value can normaly be deduced from the unit size.
 * However if you need to support several DiskOnChip devices with diffrent
 * unit sizes, you may need to define the smallest unit size, while defining
 * the largest number of logical sectors in a logical unit
 */

#ifndef FL_ASSUMED_MAX_SECTORS_PER_UNIT
#define FL_ASSUMED_MAX_SECTORS_PER_UNIT (FL_ASSUMED_MIN_UNIT_SIZE>>FL_SECTOR_SIZE_BITS)
#endif /* FL_ASSUMED_MAX_SECTORS_PER_UNIT */

/* Validiy check for FL_LOW_LEVEL compilation flag.
 *
 * Starting from TrueFFS 5.1 the LOW_LEVEL was changed to FL_LOW_LEVEL
 * The reason was that it clashed with Windows NT LOW_LEVEL macro.
 */

#ifndef FL_LOW_LEVEL
#ifdef LOW_LEVEL
#define FL_LOW_LEVEL
#endif /* LOW_LEVEL */
#endif /* FL_LOW_LEVEL */


#if !defined(FL_ABS_READ_WRITE) && !defined(FS_ABS_READ_WRITE) && defined(ABS_READ_WRITE)
#define FL_ABS_READ_WRITE
#define FS_ABS_READ_WRITE
#endif

/* Validity check for FL_SYS_FUNC_RELEASE
 *
 * Starting from TrueFFS 6.0 the flExit routine calls this macro in
 * order to inform the OS/FS that it is about to leave.
 */

#ifndef FL_SYS_FUNC_RELEASE
#define FL_SYS_FUNC_RELEASE
#endif /* FL_SYS_FUNC_RELEASE */

#if !defined(FL_EXIT) && !defined(FS_EXIT) && defined(EXIT)
#define FL_EXIT
#define FS_EXIT
#endif

/* Validity check for FL_LOWER_PRIORITY_THREAD and FL_RAISE_PRIORITY_THREAD
 *
 * Starting from TrueFFS 6.0-6.2.2 the MTD waitForReady routine calls the
 * FL_LowerPriorityThread and FL_RaisePriorityThread macros allowing the OS
 * to lower the driver's priorety during the long wait.
 *
 * After 6.2.2 the name of the macros was changed to all upper case.
 */

#ifndef FL_LOWER_PRIORITY_THREAD
#ifdef FL_LowerPriorityThread
/*** Add support for older flsystem that use FL_Raise/LowerPriorityThread macros      ***/
#define FL_LOWER_PRIORITY_THREAD FL_LowerPriorityThread
#else
#define FL_LOWER_PRIORITY_THREAD(myFlash)
#endif /* FL_LowerPriorityThread */
#endif /* FL_LOWER_PRIORITY_THREAD */

#ifndef FL_RAISE_PRIORITY_THREAD
#ifdef FL_RaisePriorityThread
/*** Add support for older flsystem that use FL_Raise/LowerPriorityThread macros      ***/
#define FL_RAISE_PRIORITY_THREAD FL_RaisePriorityThread
#else
#define FL_RAISE_PRIORITY_THREAD(myFlash)
#endif /* FL_RaisePriorityThread */
#endif /* FL_RAISE_PRIORITY_THREAD */

#ifndef FL_LowerPriorityThread
#define FL_LowerPriorityThread(myFlash)
#endif /* FL_LowerPriorityThread */

#ifndef FL_RaisePriorityThread
#define FL_RaisePriorityThread(myFlash)
#endif /* FL_RaisePriorityThread */


/* Validity check for FL_TFFS_SLEEP
 *
 * Note that this routine used to be called flsleep, but it's name was
 * greater resolution was required.
 */

#ifndef FL_TFFS_SLEEP
#define FL_TFFS_SLEEP(flash,microseconds)
#endif /* FL_TFFS_SLEEP */


/* Validity check for FL_MALLOC and FL_FREE macroes
 *
 * Starting from TrueFFS 5.0 the FREE and MALLOC macroes were
 * changed to FL_MALLOC and FL_FREE in order to avoid name clashes.
 * In order to keep backwards compatibility with previous flsystem.h
 * files the following new defintions checks were added.
 * if your system uses the FREE and MALLOC defintion simply comment
 * them out and customized the FL_MALLOC and FL_FREE macroes in your
 * flsystem.h file.
 */

#if (defined(MALLOC) && !defined(FL_MALLOC))
#define FL_MALLOC MALLOC
#endif /* MALLOC && ! FL_MALLOC */
#if (defined(FREE) && !defined(FL_FREE))
#define FL_FREE   FREE
#endif /* FREE && ! FL_FREE */


/* Validity check for "subFromFarPointer" and "distanceBetweenFarPointers"
 *
 * Starting from TrueFFS 6.3.0 2 new memory manipulation macro's were 
 * introduced for none flat memory architecture. They should be used when
 * memory pointers are being subtracted or a diffrence between 2 pointers 
 * is needed
 */

#ifndef subFromFarPointer
#define subFromFarPointer(base,increment)		\
       addToFarPointer(base,(-(FLSDword)(increment)))
#endif /* subFromFarPointer */

#ifndef distanceBetweenFarPointers
#define distanceBetweenFarPointers(ptr1, ptr2)		\
	(((FLDword)(ptr1)) - ((FLDword)(ptr2)))
#endif /* distanceBetweenFarPointers */


/* Validity check for FL_FAR_MALLOC and FL_FAR_FREE
 *
 * Due to the BIOS driver memory limitations a dedicated routine 
 * is used for allocating the large ram arrays.
 */

#if (defined(FL_MALLOC) && !defined(FL_FAR_MALLOC))
#define FL_FAR_MALLOC FL_MALLOC 
#endif /* FL_MALLOC && ! FL_FAR_MALLOC */

#if (defined(FL_FREE) && !defined(FL_FAR_FREE))
#define FL_FAR_FREE FL_FREE 
#endif /* FL_MALLOC && ! FL_FAR_MALLOC */


#ifndef FL_MALLOC_DMA_BUFFER
#define FL_MALLOC_DMA_BUFFER FL_FAR_MALLOC
#endif

#ifndef FL_FREE_DMA_BUFFER
#define FL_FREE_DMA_BUFFER FL_FAR_FREE
#endif


/* Validiy check for debug printing 
 *
 * Starting from TrueFFS 6.0 there are 6 types of debug print
 * In case they were not customized in flsystem.h they are defined here
 * as NULL.
 */

#ifndef DBG_PRINT_FLOW
#define DBG_PRINT_FLOW(zone,str)    /* if (zone & (ACTIVE_DEBUG_ZONE)) printf (str) */
#endif
#ifndef DBG_PRINT_ERR
#define DBG_PRINT_ERR(zone,str)     /* if (zone & (ACTIVE_DEBUG_ZONE)) printf (str) */
#endif
#ifndef DBG_PRINT_WRN
#define DBG_PRINT_WRN(zone,str)     /* if (zone & (ACTIVE_DEBUG_ZONE)) printf (str) */
#endif
#ifndef DBG_PRINT_FLOW_PRM
#define DBG_PRINT_FLOW_PRM(zone,str) /* if (zone & (ACTIVE_DEBUG_ZONE)) printf str */
#endif
#ifndef DBG_PRINT_ERR_PRM
#define DBG_PRINT_ERR_PRM(zone,str)  /* if (zone & (ACTIVE_DEBUG_ZONE)) printf str */
#endif
#ifndef DBG_PRINT_WRN_PRM
#define DBG_PRINT_WRN_PRM(zone,str)  /* if (zone & (ACTIVE_DEBUG_ZONE)) printf str */
#endif

#ifndef DFORMAT_PRINT 
#define DFORMAT_PRINT(a)             DBG_PRINT_WRN_PRM(FLZONE_FORMAT,a)
#endif 
#ifndef DEBUG_PRINT
#define DEBUG_PRINT(a)               DBG_PRINT_WRN(FLZONE_FULL,a)
#endif 


/* TrueFFS used to export several basic types. These type were changed in
 * TrueFFS 6.0 , but to allows old application based on these type to function
 * we keep exporting them 
 */

#ifndef FL_DISABLE_OLD_TRUEFFS_TYPES
typedef unsigned char  byte;        /* 8  bit unsigned variable */
typedef unsigned short word;        /* 16 bit unsigned variable */
typedef unsigned long  dword;       /* 32 bit unsigned variable */

typedef signed char  Sbyte;         /* 8  bit signed variable */
typedef signed short Sword;         /* 16 bit signed variable */
typedef signed long  Sdword;        /* 32 bit signed variable */
#endif /* FL_DISABLE_OLD_TRUEFFS_TYPES */


/* For backwards competability we make sure tffsxxx is defined as flxxx
 * 
 * Versions prior to 6.1 (when ENVIRONMENT_VARS was defined) the user was
 * required to customize 2 sets of DiskOnChip memory access routines.
 * (flxxx and flmemxxx). One set was for fast memory access and one 
 * implemented a simple for loop for maximum platform portability. Newer
 * versions automatically implement the simple for loop allowing easier 
 * customization. The new customiation model allows the user to customize
 * only the tffsxxx routines regardless of the compilation flag 
 */

#if !defined(FL_ENVIRONMENT_VARS) && defined(ENVIRONMENT_VARS)
#define FL_ENVIRONMENT_VARS
#endif

#ifdef FL_ENVIRONMENT_VARS
#ifndef tffscpy
#define tffscpy flcpy
#endif /* tffscpy */
#ifndef tffscmp
#define tffscmp flcmp
#endif /* tffscmp */
#ifndef tffsset
#define tffsset flset
#endif /* tffsset */
#endif /* FL_ENVIRONMENT_VARS */

/* Macro for converting text to string */
#ifndef FLTXT
#define FLTXT
#endif /* FLTXT */

/*****************************/
/* M-Systems forced defaults */
/*****************************/

/*  define IO memory access macros - must be defined in flsystem.h */
#ifndef FLWRITE_IO_BYTE
#define FLWRITE_IO_BYTE(val,address)      *((volatile FLByte FAR0*)(address))=(FLByte)(val)
#endif
#ifndef FLWRITE_IO_WORD
#define FLWRITE_IO_WORD(val,address)      *((volatile FLWord FAR0*)(address))=(FLWord)(val)
#endif
#ifndef FLWRITE_IO_DWORD
#define FLWRITE_IO_DWORD(val,address)     *((volatile FLDword FAR0*)(address))=(FLDword)(val)
#endif
#ifndef TFFSCPY_FROM_IO_8_BITS
#ifdef  TFFSCPY_FROM_IO
#define TFFSCPY_FROM_IO_8_BITS                    TFFSCPY_FROM_IO
#else
#define TFFSCPY_FROM_IO_8_BITS(dest,src,count)    tffscpy(dest,(void FAR0*)(src),count)
#endif
#endif /* TFFSCPY_FROM_IO_8_BITS */

#ifndef TFFSCPY_FROM_IO_16_BITS
#ifdef TFFSCPY_FROM_IO
#define TFFSCPY_FROM_IO_16_BITS                   TFFSCPY_FROM_IO
#else
#define TFFSCPY_FROM_IO_16_BITS(dest,src,count)   tffscpy(dest,(void FAR0*)(src),count)
#endif
#endif /* TFFSCPY_FROM_IO_16_BITS */

#ifndef FLREAD_IO_BYTE
#define FLREAD_IO_BYTE(address)           (*((volatile FLByte FAR0*)(address)))
#endif
#ifndef FLREAD_IO_WORD
#define FLREAD_IO_WORD(address)           (*((volatile FLWord FAR0*)(address)))
#endif
#ifndef FLREAD_IO_DWORD
#define FLREAD_IO_DWORD(address)          (*((volatile FLDword FAR0*)(address)))
#endif

#ifndef TFFSCPY_TO_IO_8_BITS
#ifdef TFFSCPY_TO_IO
#define TFFSCPY_TO_IO_8_BITS                     TFFSCPY_TO_IO
#else
#define TFFSCPY_TO_IO_8_BITS(dest,src,count)     tffscpy((void FAR0*)(dest),src,count)
#endif
#endif /* TFFSCPY_TO_IO_8_BITS */

#ifndef TFFSCPY_TO_IO_16_BITS
#ifdef TFFSCPY_TO_IO
#define TFFSCPY_TO_IO_16_BITS                     TFFSCPY_TO_IO
#else
#define TFFSCPY_TO_IO_16_BITS(dest,src,count)     tffscpy((void FAR0*)(dest),src,count)
#endif
#endif /* TFFSCPY_TO_IO_16_BITS */

#ifndef TFFSSET_IO_8_BITS
#ifdef TFFSSET_IO
#define TFFSSET_IO_8_BITS                         TFFSSET_IO
#else
#define TFFSSET_IO_8_BITS(dest,val,count)         tffsset((void FAR0*)(dest),val,count)
#endif
#endif /* TFFSSET_IO_8_BITS */

#ifndef TFFSSET_IO_16_BITS
#ifdef TFFSSET_IO 
#define TFFSSET_IO_16_BITS                        TFFSSET_IO 
#else
#define TFFSSET_IO_16_BITS(dest,val,count)        tffsset((void FAR0*)(dest),val,count)
#endif
#endif /* TFFSSET_IO_16_BITS */


/* The FAT-LITE/SURE-FS API definitions were added the FL_ prefix.
 *
 * Starting from TrueFFS 6.2
 */


#ifndef FS_FILES
#ifdef FILES
#define FS_FILES               FILES
#endif /* FILES         */
#ifdef FL_FILES
#define FS_FILES               FL_FILES
#endif /* FL_FILES         */
#endif /* FS_FILES */

#if defined(FS_FILES) && (FS_FILES <= 0)
#undef FS_FILES
#endif

#if defined(FS_MAX_FSOS) && ((FS_MAX_FSOS <= 0) || !defined(FS_FILES))
#undef FS_MAX_FSOS
#endif

#if defined(FS_SUPPORT_FILE_CACHE) && !defined(FS_MAX_FSOS)
#undef FS_SUPPORT_FILE_CACHE
/* you need FSOs to define the cache size per file type */
#endif

#if defined(FS_SUPPORT_FILE_CACHE) && !defined(FL_EXTENDED_SECTOR_CACHE)
#define FL_EXTENDED_SECTOR_CACHE
#endif

#if defined(FS_MAX_FSOS) && !defined(FS_MM_PERFORMANCE_TUNEUPS)
#define FS_MM_PERFORMANCE_TUNEUPS
#endif

#if defined(FS_MAX_FSOS) && !defined(STATIC_FS_DB)
#if FS_MAX_FSOS >= 2
#define STATIC_FS_DB	= { DEFAULT_FILE(0, 0), DEFINE_FSO(NULL, NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0) }
#else
#define STATIC_FS_DB	= { DEFAULT_FILE(0, 0) }
#endif
#endif

#if defined(SUB_DIRECTORY) && !defined(FS_SUB_DIRECTORY)
#define FS_SUB_DIRECTORY
#endif

#if defined(RENAME_FILE) && !defined(FS_RENAME_FILE)
#define FS_RENAME_FILE
#endif

#ifndef FILE_IS_ROOT_DIR
#define FILE_IS_ROOT_DIR		FL_FILE_IS_ROOT_DIR
#endif

#ifndef FILE_MODIFIED
#define FILE_MODIFIED			FL_FILE_MODIFIED
#endif

#ifndef FILE_IS_OPEN
#define FILE_IS_OPEN			FL_FILE_IS_OPEN
#endif

#ifndef FILE_IS_DIRECTORY
#define FILE_IS_DIRECTORY		FL_FILE_IS_DIRECTORY
#endif

#ifndef FILE_READ_ONLY
#define FILE_READ_ONLY			FL_FILE_READ_ONLY
#endif

#ifndef FILE_MUST_OPEN
#define FILE_MUST_OPEN			FL_FILE_MUST_OPEN
#endif

#ifndef ATTR_READ_ONLY
#define ATTR_READ_ONLY			FL_ATTR_READ_ONLY
#endif

#ifndef ATTR_HIDDEN
#define ATTR_HIDDEN			FL_ATTR_HIDDEN
#endif

#ifndef ATTR_SYSTEM
#define ATTR_SYSTEM			FL_ATTR_SYSTEM
#endif

#ifndef ATTR_VOL_LABEL
#define ATTR_VOL_LABEL			FL_ATTR_VOL_LABEL
#endif

#ifndef ATTR_DIRECTORY
#define ATTR_DIRECTORY			FL_ATTR_DIRECTORY
#endif

#ifndef ATTR_ARCHIVE
#define ATTR_ARCHIVE			FL_ATTR_ARCHIVE
#endif

#ifndef SEEK_START
#define SEEK_START			FL_SEEK_START
#endif

#ifndef SEEK_CURR
#define SEEK_CURR			FL_SEEK_CURR
#endif

#ifndef SEEK_END
#define SEEK_END			FL_SEEK_END
#endif

#ifndef SET_DATETIME
#define SET_DATETIME			FL_SET_DATETIME
#endif 

#ifndef SET_ATTRIBUTES 
#define SET_ATTRIBUTES			FL_SET_ATTRIBUTES
#endif 

#ifndef FIND_BY_HANDLE 
#define FIND_BY_HANDLE			FL_FIND_BY_HANDLE
#endif 

#ifndef SET_CREATE_DATETIME 
#define SET_CREATE_DATETIME		FL_SET_CREATE_DATETIME
#endif 

#ifndef ACCESS_READ_WRITE 
#define	ACCESS_READ_WRITE		FL_ACCESS_READ_WRITE
#endif 

#ifndef ACCESS_CREATE 
#define	ACCESS_CREATE			FL_ACCESS_CREATE
#endif 

#ifndef OPEN_FOR_READ 
#define	OPEN_FOR_READ			FL_OPEN_FOR_READ
#endif 

#ifndef OPEN_FOR_UPDATE 
#define	OPEN_FOR_UPDATE			FL_OPEN_FOR_UPDATE
#endif 

#ifndef OPEN_FOR_WRITE 
#define	OPEN_FOR_WRITE			FL_OPEN_FOR_WRITE
#endif 


#if defined(FL_TRANSLATE_FROM_UNICODE) && defined(FL_TRANSLATE_TO_UNICODE)
#define FILENAMES_INTERNAL_UNICODE_CONVERSION		/* user-defined functions */

#elif defined(FL_LONG_FILENAMES_ASCII_SUPPORT)
#define FL_TRANSLATE_FROM_UNICODE	unicodeToAscii
#define FL_TRANSLATE_TO_UNICODE		asciiToUnicode

#define FILENAMES_INTERNAL_UNICODE_CONVERSION

#elif defined(FL_LONG_FILENAMES_UTF8_SUPPORT)
#define FL_TRANSLATE_FROM_UNICODE	unicodeToUTF8
#define FL_TRANSLATE_TO_UNICODE		UTF8ToUnicode

#define FILENAMES_INTERNAL_UNICODE_CONVERSION

#endif

#if defined(FL_EXTENDED_SECTOR_CACHE) && (!defined(FS_FILES) || (FS_FILES == 0))
#undef FL_EXTENDED_SECTOR_CACHE
#endif
 
#if defined(FL_EXTENDED_SECTOR_CACHE) && !defined(FS_DATA_CACHE_SIZE) 
#define FS_DATA_CACHE_SIZE(socket, partition, logPartition)		200 
#endif 
 
#if defined(FAT_12BIT) && !defined(FS_FAT_12BIT) 
#define FS_FAT_12BIT 
#endif 

/******************************** MTD Macros ********************************************/ 

#ifndef FL_CHANGE_READ_ACCESS_TIME
#define FL_CHANGE_READ_ACCESS_TIME(wTimeNanoSec,socket)
#endif /* FL_CHANGE_READ_ACCESS_TIME */
	
/****************************************************************************************/ 


#endif /* _FL_CHK_DEFS_H_ */
