/***********************************************************************************/
/*                        M-Systems Confidential                                   */
/*           Copyright (C) M-Systems Flash Disk Pioneers Ltd. 1995-2003            */
/*                         All Rights Reserved                                     */
/***********************************************************************************/
/*                            NOTICE OF M-SYSTEMS OEM                              */
/*                           SOFTWARE LICENSE AGREEMENT                            */
/*                                                                                 */
/*      THE USE OF THIS SOFTWARE IS GOVERNED BY A SEPARATE LICENSE                 */
/*      AGREEMENT BETWEEN THE OEM AND M-SYSTEMS. REFER TO THAT AGREEMENT           */
/*      FOR THE SPECIFIC TERMS AND CONDITIONS OF USE,                              */
/*      OR CONTACT M-SYSTEMS FOR LICENSE ASSISTANCE:                               */
/*      E-MAIL = info@m-sys.com                                                    */
/***********************************************************************************/

/*
 * $Log:   V:/PVCSDB/DiskOnChip/archives/Testing/TrueFFS 6.3/Drop 2.5/3/common/flreq.h-arc  $
 * 
 *    Rev 1.2   May 10 2005 13:07:00   oris
 * - Bug fix : Removed far qualifiers.
 * 
 *    Rev 1.1   Apr 19 2005 02:57:34   oris
 * - Changed irFlags field to FLDword instead of unsigned.
 * 
 *    Rev 1.0   Mar 27 2005 09:27:26   oris
 * Initial revision.
 * 
 *    Rev 1.0   Dec 09 2004 18:23:44   oris
 * Initial revision.
 * 
 *    Rev 1.2   Aug 09 2004 19:22:22   OriS
 * Spelling mistake
 * 
 *    Rev 1.1   Sep 30 2003 17:59:06   oris
 * Changed irPath pointer type.
 * 
 *    Rev 1.0   Apr 09 2003 12:16:00   OriS
 * Initial revision.
 * 
 */

#ifndef FLREQ_H
#define FLREQ_H

#include "flbase.h"
#include "_flreq.h"

#define VOLUME_NOT_OCCUPIED	0
#define VOLUME_LOW_LVL_MOUNTED	1  /* Volume is mounted for low level operations */
#define VOLUME_MOUNTED		2  /* Volume is mounted                          */
#define VOLUME_12BIT_FAT	4  /* Volume uses 12-bit FAT                     */
#define VOLUME_ABS_MOUNTED	8  /* Volume is mounted for abs calls            */
/*#define VOLUME_WRITE_PROTECTED	16	Volume is write protected - not longer in use */
#define VOLUME_OCCUPIED		32 /* Volume record in use                       */
#define VOLUME_MOUNTED_NO_MBR	64
#define VOLUME_MOUNTED_ON_RANGE	128

typedef unsigned FLHandle;        /* Handle of an open file or drive.   */
                                  /* Actually an index to file table or */
                                  /* drive table.                       */

/*----------------------------------------------------------------------*/
/*                            I O r e q                                 */
/*                                                                      */
/* IOreq is a common structure passed to all file-system functions.     */
/* Refer to the description of individual functions for specific usage  */
/* of fields. Some fields have different names when used by different   */
/* functions, hence the use of unions.                                  */
/*                                                                      */
/*----------------------------------------------------------------------*/

typedef struct {
  FLHandle   irHandle;         /* Handle of file or drive for operation*/
  FLDword    irFlags;          /* function-specific flags              */
  void     * irPath;	       /* path of file for operation 		*/
  void	   * irData;           /* Pointer to user-buffer for operation */
  FLSDword   irLength;         /* No. of bytes, size or position for   */
                               /* operation                            */
  FLSDword   irCount;          /* Count or offset for operaion         */
} IOreq;

/* definiftions for absolute read & write */
#define irSectorCount   irCount
#define irSectorNo      irLength

/* definitions for physical read & write */
#define irByteCount     irCount
#define irAddress       irLength

/* definitions for physical erase */
#define irUnitCount     irCount
#define irUnitNo        irLength

/* definitions for writing exb file */
#define irWindowBase    irCount
#define irData2		irPath

#endif /* FLREQ_H */
