/***********************************************************************************/
/*                        M-Systems Confidential                                   */
/*           Copyright (C) M-Systems Flash Disk Pioneers Ltd. 1995-2003            */
/*                         All Rights Reserved                                     */
/***********************************************************************************/
/*                            NOTICE OF M-SYSTEMS OEM                              */
/*                           SOFTWARE LICENSE AGREEMENT                            */
/*                                                                                 */
/*      THE USE OF THIS SOFTWARE IS GOVERNED BY A SEPARATE LICENSE                 */
/*      AGREEMENT BETWEEN THE OEM AND M-SYSTEMS. REFER TO THAT AGREEMENT           */
/*      FOR THE SPECIFIC TERMS AND CONDITIONS OF USE,                              */
/*      OR CONTACT M-SYSTEMS FOR LICENSE ASSISTANCE:                               */
/*      E-MAIL = info@m-sys.com                                                    */
/***********************************************************************************/

/*
 * $Log:   V:/PVCSDB/DiskOnChip/archives/Testing/TrueFFS 6.3/Drop 2.5/3/surefs/src/fsdev.h-arc  $
 * 
 *    Rev 1.2   Apr 04 2005 20:19:42   oris
 * - Cosmetics
 * 
 *    Rev 1.1   Mar 28 2005 01:52:32   eugen
 * added extern "C" to declarations
 * 
 *    Rev 1.0   Mar 27 2005 09:26:52   oris
 * Initial revision.
 * 
 *    Rev 1.3   Feb 08 2005 17:17:54   eugen
 * Replace use of packed structures with byte arrays
 * 
 *    Rev 1.2   Jan 05 2005 21:09:32   eugen
 * Commentaries, headers
 * 
 *    Rev 1.1   Dec 23 2004 19:35:54   oris
 * Drop 2.1
 * 
 *    Rev 1.0   Dec 09 2004 18:22:18   oris
 * Initial revision.
 * 
 *    Rev 1.5   Sep 30 2003 17:56:24   oris
 * Force include of dosformt.h file
 * 
 *    Rev 1.4   Sep 01 2003 19:10:18   oris
 * - Changed comments.
 * 
 *    Rev 1.3   Jun 16 2003 01:17:46   oris
 * Added TFFS_DLL_API prefix.
 * 
 *    Rev 1.2   May 11 2003 08:25:36   OriS
 * Moved format irFlags definition to flformat.h
 * 
 *    Rev 1.1   May 08 2003 23:18:22   OriS
 * Added SUPPORT_RUGGED_FILE_SYSTEM capability.
 * 
 *    Rev 1.0   Apr 09 2003 12:15:58   OriS
 * Initial revision.
 * 
 */

#ifndef FSDEV_H
#define FSDEV_H

#include "flreq.h"
#include "flfuncno.h"
#include "dosformt.h"

#include "_fsdev.h"

#include "fsdb.h"
/* even if FSDB is not included "ensure" and "defrag" facilities can still work
if you use flOpenMMfile */

#ifdef __cplusplus
extern "C"
{
#endif /* __cplusplus */

FLStatus addFSVolume(FLByte socket, FLByte partition, FLByte logPartition);
FLStatus removeFSVolume(FLByte socket, FLByte partition, FLByte logPartition);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* FSDEV_H */
