/* msgQLib.h - message queue library header file */

/* Copyright 1984-2003 Wind River Systems, Inc. */

/*
modification history
--------------------
02q,26oct04,fr	 added msgQOpenInit() routine (SPR 101491)
02p,24oct03,aeg  moved common definitions with user side to msgQLibCommon.h
02o,20jun03,ymz  updated year of copyright.
02n,14mar03,dcc  moved MSG_Q_ID definition to types/vxWind.h.
02m,19oct01,bwa  Added MSG_Q_EVENTSEND_ERR_NOTIFY option.
02l,17apr98,rlp  canceled MSG_Q_INFO modification for backward compatibility.
02k,04nov97,rlp  modified MSG_Q_INFO structure for tracking messages sent.
02j,13jul93,wmd  use MEM_ROUND_UP to determine MSG_NODE_SIZE.
02i,22sep92,rrr  added support for c++
02h,04jul92,jcf  cleaned up.
01g,26may92,rrr  the tree shuffle
01f,04oct91,rrr  passed through the ansification filter
		  -changed copyright notice
01e,05oct90,dnw  changed MSG_Q_INFO structure.
01d,05oct90,dnw  changed function declarations for new interface.
01c,05oct90,shl  added ANSI function prototypes.
                 made #endif ANSI style.
                 added copyright notice.
01b,07aug90,shl  moved function declarations to end of file.
01a,10may90,dnw  written
*/

#ifndef __INCmsgQLibh
#define __INCmsgQLibh

#ifdef __cplusplus
extern "C" {
#endif

#include "vxWorks.h"
#include "msgQLibCommon.h"


/* macros */

/* The following macro determines the number of bytes needed to buffer
 * a message of the specified length.  The node size is rounded up for
 * efficiency.  The total buffer space required for a pool for
 * <maxMsgs> messages each of up to <maxMsgLength> bytes is:
 *
 *    maxMsgs * MSG_NODE_SIZE (maxMsgLength)
 */

#define MSG_NODE_SIZE(msgLength) \
	(MEM_ROUND_UP((sizeof (MSG_NODE) + msgLength)))

/* function declarations */

extern STATUS 	msgQLibInit (void);
extern void 	msgQShowInit (void);
extern void	msgQOpenInit (void);
extern STATUS 	msgQShow (MSG_Q_ID msgQId, int level);

#ifdef __cplusplus
}
#endif

#endif /* __INCmsgQLibh */
