/**
   \file        niDriveLetterAlloc.h
   \author      Charles Crain
   \date        01/09/2006

   COPYRIGHT 2006. NATIONAL INSTRUMENTS. ALL RIGHTS RESERVED.
*/

#ifndef ___ni_niDriveLetterAlloc_h___
#define ___ni_niDriveLetterAlloc_h___

#ifdef __cplusplus
extern "C" {
#endif

   /** Init routine for this library. */
   void niDriveLetterInit(void);

   /**
      Return a unique drive letter between
      NI_DRIVE_LETTER_FIRST and 'z'.
    */
   char niDriveLetterAlloc(void);

   /**
      Call this when you are done with a particular
      drive letter.  Note there is currently no guard against
      double-frees, and doing so will cause undefined behavior.
    */
   void niDriveLetterFree(char driveLetter);

#ifdef __cplusplus
};
#endif

#endif /* ___ni_niDriveLetterAlloc_h___ */
