/* niTimestampLib.h - NI-specific extensions providing a timestamp API */

/* Copyright 2005 National Instruments Corp. */

#ifndef __INCniTimestampLibh 
#define __INCniTimestampLibh

#ifdef __cplusplus
extern "C" {
#endif

extern unsigned int gTickTimestamp;

/* WindView specific timestamp code */
extern unsigned int niVxTimestamp();
extern unsigned int niVxTimestampLock();
extern int niVxTimestampEnable();
extern int niVxTimestampDisable();
extern int niVxTimestampConnect();
extern unsigned long niVxTimestampPeriod();
extern unsigned long niVxTimestampFreq();
extern void niVxTimestampTick();

/* General 32- and 64-bit timestamp API. Use this. */
extern unsigned long niTimestamp32();
extern unsigned long long niTimestamp64();
extern void niTimestampHiLo(unsigned long*, unsigned long*);
extern unsigned long niTimestampFreq();
#if CPU == PPC603 || CPU == PPC860
#define niTimestamp32Fast(lo) __asm__ ("mftb	%0\n" : "=r" (lo))
#define niTimestampHiLoFast(hi, lo) __asm__ ( \
	"mftb	9\n" \
	"mftbu	10\n" \
	"mftb	%0\n" \
	"subc	9, %0, 9\n" \
	"addze	%1,10\n" \
	: "=r" (lo), "=r" (hi) : : "9", "10", "cc" \
);
#endif

#ifdef __cplusplus
}
#endif

#endif /* __INCniTimestampLibh */

