/* kernelLibP.h - private header file for kernelLib.c */

/* Copyright 1984-2005 Wind River Systems, Inc. */

/*
modification history
--------------------
01d,04feb05,pch  SPR 102772: add usrKernelIntStkSizeAdj()
01c,07apr03,to   removed activeQHead.
01b,22sep92,rrr  added support for c++
01a,04jul92,jcf  created.
*/

#ifndef __INCkernelLibPh
#define __INCkernelLibPh

#ifdef __cplusplus
extern "C" {
#endif
#include "kernelLib.h"
#include "qLib.h"

/* variable declarations */

extern BOOL	kernelState;		/* mutex to enter kernel state */
extern BOOL	kernelIsIdle;		/* boolean reflecting idle state */
extern BOOL	roundRobinOn;		/* state of round robin scheduling */
extern ULONG	roundRobinSlice;	/* round robin task slice in ticks */
extern int 	rootTaskId;		/* root task id */
extern char *	pRootMemStart;		/* bottom of root task's memory */
extern unsigned rootMemNBytes;		/* actual root task memory size */
extern Q_HEAD	tickQHead;		/* queue for timeouts/delays/wdogs */
extern Q_HEAD	readyQHead;		/* queue for task ready queue */

/* prototypes */

extern void usrKernelIntStkSizeAdj(unsigned *, unsigned *, unsigned *,
				   unsigned *);
					/* stack calculation configlette */

#ifdef __cplusplus
}
#endif

#endif /* __INCkernelLibPh */
