/*---------------------------------------------------------------------------
               ----> DO NOT REMOVE THE FOLLOWING NOTICE <----

      Copyright (c) 2003 - 2004 Datalight, Inc.  All Rights Reserved.

  Datalight, Incorporated is a Washington State corporation located at:

        21520 30th Dr SE, Suite 110,      Tel:  425-951-8086
        Bothell, WA  98021                Fax:  425-951-8094
        USA                               Http://www.datalight.com

  This software, including without limitation, all source code and documen-
  tation, is the confidential, trade secret property of Datalight, Inc., and
  is protected under the copyright laws of the United States and other juris-
  dictions.

  ---> Portions of the software are patent pending <---

  In addition to civil penalties for infringement of copyright under applic-
  able U.S. law, 17 U.S.C. 1204 provides criminal penalties for violation of
  (a) the restrictions on circumvention of copyright protection systems found
  in 17 U.S.C. 1201 and (b) the protections for the integrity of copyright
  management information found in 17 U.S.C. 1202.

  U.S. Government Restricted Rights:  Use, duplication, reproduction, or
  transfer of this commercial product and accompanying documentation is
  restricted in accordance with FAR 12.212 and DFARS 227.7202 and by a
  License Agreement.

  IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS PROTECTED UNDER A
  SOURCE CODE AGREEMENT, NON-DISCLOSURE AGREEMENT (NDA), OR SIMILAR BINDING
  CONTRACT BETWEEN DATALIGHT, INC. AND THE LICENSEE ("BINDING AGREEMENT").
  YOUR RIGHT, IF ANY, TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,
  IS SUBJECT TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT.  BY USING
  THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE TO BE BOUND BY
  THE TERMS OF THE BINDING AGREEMENT.  CONTACT DATALIGHT, INC. AT THE ADDRESS
  SET FORTH ABOVE IF YOU OBTAINED THIS SOFTWARE IN ERROR.
---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
                              Description

    Boot sector in binary form for an x86. To be included in IO layer for x86 systems.

---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
                              Revision History
    $Log: rlbcx86.h $
    Revision 1.1  2004/12/31 03:17:52  Pauli
    Initial revision
    Revision 1.1  2004/12/31 03:17:52Z  Garyp
    Initial revision
    Revision 1.1  2004/12/31 02:17:52Z  pauli
    Initial revision
    Revision 1.2  2004/12/31 01:17:52Z  GaryP
    Updated to use indents of 4, hard tabs of 8 (if used), and a standard
    comment style.
    Revision 1.1  2004/09/23 00:51:58Z  brandont
    Initial revision
---------------------------------------------------------------------------*/

unsigned char   gbaTfsBootSector[] = {
    0x33, 0xFF, 0x8E, 0xDF, 0xCD, 0x12, 0xB1, 0x06,     /* 3....... */
    0xD3, 0xE0, 0x2D, 0x20, 0x00, 0x8E, 0xC0, 0xBE,     /* ..- .... */
    0x00, 0x7C, 0xB9, 0x00, 0x02, 0xFC, 0xF3, 0xA4,     /* .|...... */
    0x2D, 0x40, 0x00, 0xFA, 0x8E, 0xD0, 0xBC, 0x00,     /* -@...... */
    0x04, 0xFB, 0x06, 0xB8, 0x28, 0x00, 0x50, 0xCB,     /* ....(.P. */
    0x06, 0x1F, 0xBE, 0xA9, 0x01, 0xE8, 0xB1, 0x00,     /* ........ */
    0xE8, 0x47, 0x01, 0xEB, 0x4B, 0x00, 0x00, 0x00,     /* .G..K... */
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,     /* ........ */
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,     /* ........ */
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,     /* ........ */
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,     /* ........ */
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,     /* ........ */
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,     /* ........ */
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,     /* ........ */
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,     /* ........ */
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,     /* ........ */
    0x66, 0xB9, 0x01, 0x00, 0x00, 0x00, 0xC4, 0x1E,     /* f....... */
    0xE4, 0x01, 0x66, 0x8B, 0x3E, 0xE8, 0x01, 0xE8,     /* ..f.>... */
    0x60, 0x00, 0xC4, 0x1E, 0xE4, 0x01, 0x66, 0xA1,     /* `.....f. */
    0xEC, 0x01, 0x66, 0x26, 0x39, 0x07, 0x75, 0x0A,     /* ..f&9.u. */
    0x26, 0x8A, 0x47, 0x08, 0x24, 0xF0, 0x3C, 0x40,     /* &.G.$.<@ */
    0x74, 0x08, 0xBE, 0xB9, 0x01, 0xE8, 0x31, 0x00,     /* t.....1. */
    0xEB, 0xFE, 0xBE, 0xC8, 0x01, 0xE8, 0x29, 0x00,     /* ......). */
    0x66, 0x8B, 0x0E, 0xF4, 0x01, 0x66, 0x8B, 0x3E,     /* f....f.> */
    0xF0, 0x01, 0xC4, 0x1E, 0xE4, 0x01, 0xE8, 0x29,     /* .......) */
    0x00, 0x33, 0xC0, 0x8E, 0xC0, 0xBB, 0x84, 0x00,     /* .3...... */
    0xA0, 0xFC, 0x01, 0xBA, 0xFF, 0xFF, 0x26, 0x89,     /* ......&. */
    0x07, 0x26, 0x89, 0x57, 0x02, 0xFF, 0x2E, 0xE4,     /* .&.W.... */
    0x01, 0xBB, 0x07, 0x00, 0xB4, 0x0E, 0x8A, 0x04,     /* ........ */
    0x3C, 0x00, 0x74, 0x05, 0xCD, 0x10, 0x46, 0xEB,     /* <.t...F. */
    0xF0, 0xC3, 0xBE, 0x99, 0x01, 0x89, 0x5C, 0x04,     /* ......\. */
    0x8C, 0x44, 0x06, 0x66, 0x89, 0x7C, 0x08, 0x66,     /* .D.f.|.f */
    0x51, 0x66, 0x33, 0xD2, 0x66, 0x8B, 0xC7, 0x66,     /* Qf3.f..f */
    0x0F, 0xB7, 0x1E, 0x95, 0x01, 0x66, 0xF7, 0xF3,     /* .....f.. */
    0x2B, 0xDA, 0x66, 0x3B, 0xCB, 0x72, 0x02, 0x8B,     /* +.f;.r.. */
    0xCB, 0x89, 0x4C, 0x02, 0xB4, 0x42, 0x8A, 0x16,     /* ..L..B.. */
    0xFC, 0x01, 0xCD, 0x13, 0x72, 0x20, 0x66, 0x59,     /* ....r fY */
    0x66, 0x0F, 0xB7, 0x44, 0x02, 0x66, 0x2B, 0xC8,     /* f..D.f+. */
    0x74, 0x13, 0x66, 0x03, 0xF8, 0xC1, 0xE0, 0x09,     /* t.f..... */
    0x01, 0x44, 0x04, 0xEB, 0xBE, 0xBE, 0xC6, 0x01,     /* .D...... */
    0xE8, 0x9E, 0xFF, 0xEB, 0xFE, 0xC3, 0x8B, 0x0E,     /* ........ */
    0x95, 0x01, 0xA1, 0x97, 0x01, 0xF7, 0xE1, 0x93,     /* ........ */
    0x66, 0x57, 0x58, 0x5A, 0xF7, 0xF3, 0x92, 0xF6,     /* fWXZ.... */
    0xF1, 0x8A, 0xCC, 0xFE, 0xC1, 0x8A, 0xEA, 0xB2,     /* ........ */
    0x00, 0xC1, 0xEA, 0x02, 0x0A, 0xCA, 0x8A, 0xF0,     /* ........ */
    0x8A, 0x16, 0xFC, 0x01, 0xC4, 0x5C, 0x04, 0x8A,     /* .....\.. */
    0x44, 0x02, 0xB4, 0x02, 0xCD, 0x13, 0x72, 0xC5,     /* D.....r. */
    0xEB, 0xAC, 0xB4, 0x08, 0x8A, 0x16, 0xFC, 0x01,     /* ........ */
    0xCD, 0x13, 0x72, 0xB9, 0x80, 0xE1, 0x3F, 0x88,     /* ..r...?. */
    0x0E, 0x95, 0x01, 0xB2, 0x00, 0x86, 0xD6, 0x42,     /* .......B */
    0x89, 0x16, 0x97, 0x01, 0xC3, 0x12, 0x00, 0x02,     /* ........ */
    0x00, 0x10, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00,     /* ........ */
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,     /* ........ */
    0x00, 0x52, 0x65, 0x6C, 0x69, 0x61, 0x6E, 0x63,     /* .Relianc */
    0x65, 0x20, 0x42, 0x6F, 0x6F, 0x74, 0x3A, 0x20,     /* e Boot: */
    0x00, 0x6E, 0x6F, 0x74, 0x20, 0x62, 0x6F, 0x6F,     /* .not boo */
    0x74, 0x61, 0x62, 0x6C, 0x65, 0x00, 0x66, 0x61,     /* table.fa */
    0x6C, 0x6F, 0x61, 0x64, 0x69, 0x6E, 0x67, 0x20,     /* loading */
    0x78, 0x78, 0x78, 0x78, 0x78, 0x78, 0x78, 0x78,     /* xxxxxxxx */
    0x2E, 0x79, 0x79, 0x79, 0x2E, 0x2E, 0x2E, 0x0D,     /* .yyy.... */
    0x0A, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0x00,     /* ......p. */
    0x00, 0x00, 0x00, 0x00, 0x49, 0x4E, 0x4F, 0x44,     /* ....INOD */
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,     /* ........ */
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x55, 0xAA      /* ......U. */
};
