/*---------------------------------------------------------------------------
               ----> DO NOT REMOVE THE FOLLOWING NOTICE <----

      Copyright (c) 2003 - 2005 Datalight, Inc.  All Rights Reserved.

  Datalight, Incorporated is a Washington State corporation located at:

        21520 30th Dr SE, Suite 110,      Tel:  425-951-8086
        Bothell, WA  98021                Fax:  425-951-8094
        USA                               Http://www.datalight.com

  This software, including without limitation, all source code and documen-
  tation, is the confidential, trade secret property of Datalight, Inc., and
  is protected under the copyright laws of the United States and other juris-
  dictions.

  ---> Portions of the software are patent pending <---

  In addition to civil penalties for infringement of copyright under applic-
  able U.S. law, 17 U.S.C. 1204 provides criminal penalties for violation of
  (a) the restrictions on circumvention of copyright protection systems found
  in 17 U.S.C. 1201 and (b) the protections for the integrity of copyright
  management information found in 17 U.S.C. 1202.

  U.S. Government Restricted Rights:  Use, duplication, reproduction, or
  transfer of this commercial product and accompanying documentation is
  restricted in accordance with FAR 12.212 and DFARS 227.7202 and by a
  License Agreement.

  IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS PROTECTED UNDER A
  SOURCE CODE AGREEMENT, NON-DISCLOSURE AGREEMENT (NDA), OR SIMILAR BINDING
  CONTRACT BETWEEN DATALIGHT, INC. AND THE LICENSEE ("BINDING AGREEMENT").
  YOUR RIGHT, IF ANY, TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,
  IS SUBJECT TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT.  BY USING
  THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE TO BE BOUND BY
  THE TERMS OF THE BINDING AGREEMENT.  CONTACT DATALIGHT, INC. AT THE ADDRESS
  SET FORTH ABOVE IF YOU OBTAINED THIS SOFTWARE IN ERROR.
---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
                              Description
---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
                              Revision History
    $Log: rlfsconf.h $
    Revision 1.1  2005/09/09 21:55:38  Pauli
    Initial revision
    Revision 1.1  2005/09/09 22:55:38Z  Pauli
    Initial revision
    Revision 1.3  2005/09/09 23:55:37Z  brandont
    Changed the primary partition type from 0xCC to 0x07.
    Revision 1.2  2005/08/11 00:52:52Z  brandont
    Removed two obsolete defines TFS_DOTDOT and
    TFS_UNICODE_NAME.
    Revision 1.1  2005/06/22 21:53:30Z  brandont
    Initial revision
---------------------------------------------------------------------------*/


/*  File system name
*/
#define TFS_SZPROG_NAME         "Reliance"


/*  Reliance CDF path and file name limits

    Reliance will not allow the file names or paths that exceed this value to
    be used on the media.

    Note: Port specific limits may be less than CDF limits
*/
#define REL_CDF_NAME_LENGTH     260     /* maximum filename length */
#define REL_CDF_PATH_LENGTH     260     /* maximum full path length */


/*  Reliance CDF directory entry limit

    This is the number of entries that can appear in a single subdirectory

    Note: Bug in the code prevents 0 from implying no limit
*/
#define TFS_DIR_LIMIT           65535


/*  Reliance CDF partition ID
*/
#define TFS_PARTITION_ID        0x07    /* Primary partition ID */
#define TFS_EXTENDED_ID         0xCD    /* Extended partition ID */


/*
    -------------------------------------------------------------------------
    Temporary location
    -------------------------------------------------------------------------
*/


/*  for mixed Pascal / C environments
*/
#define TFS_CDECL


/*  Enable log file (obsolete)

    Note:  Log file must be on a non-Reliance drive
*/
#define TFS_ENABLE_LOGGING      1


/*  Boolean for whether Reliance file/directory names are case sensitive.
    (obsolete by CDF)

    Incasensitive: 0
    Casesensitive: 1
*/
#define TFS_CASE_SENSITIVE      0


/*  Enable the kill test functionality (obsolete)
*/
#define TFS_TEST_KILL           0


