/*---------------------------------------------------------------------------
               ----> DO NOT REMOVE THE FOLLOWING NOTICE <----

      Copyright (c) 2003 - 2004 Datalight, Inc.  All Rights Reserved.

  Datalight, Incorporated is a Washington State corporation located at:

        21520 30th Dr SE, Suite 110,      Tel:  425-951-8086
        Bothell, WA  98021                Fax:  425-951-8094
        USA                               Http://www.datalight.com

  This software, including without limitation, all source code and documen-
  tation, is the confidential, trade secret property of Datalight, Inc., and
  is protected under the copyright laws of the United States and other juris-
  dictions.

  ---> Portions of the software are patent pending <---

  In addition to civil penalties for infringement of copyright under applic-
  able U.S. law, 17 U.S.C. 1204 provides criminal penalties for violation of
  (a) the restrictions on circumvention of copyright protection systems found
  in 17 U.S.C. 1201 and (b) the protections for the integrity of copyright
  management information found in 17 U.S.C. 1202.

  U.S. Government Restricted Rights:  Use, duplication, reproduction, or
  transfer of this commercial product and accompanying documentation is
  restricted in accordance with FAR 12.212 and DFARS 227.7202 and by a
  License Agreement.

  IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS PROTECTED UNDER A
  SOURCE CODE AGREEMENT, NON-DISCLOSURE AGREEMENT (NDA), OR SIMILAR BINDING
  CONTRACT BETWEEN DATALIGHT, INC. AND THE LICENSEE ("BINDING AGREEMENT").
  YOUR RIGHT, IF ANY, TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,
  IS SUBJECT TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT.  BY USING
  THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE TO BE BOUND BY
  THE TERMS OF THE BINDING AGREEMENT.  CONTACT DATALIGHT, INC. AT THE ADDRESS
  SET FORTH ABOVE IF YOU OBTAINED THIS SOFTWARE IN ERROR.
---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
                              Description

    Contains module numbers for all of the modules in TFS, including all of
    the O/S Integration layers. Each module has a unique number for use in
    automated prototyping.

    0-99     Tfs core modules
    100-199     Tfs test suite modules
    200-299     Tfs utility modules
    300-399     Tfs generic OS Integration Layer modules
    400-499     Tfs DOS O/S Integration Layer modules
    500-999     Port specific modules (not defined in tfsmods.h)

    The numbers are used to automatically encompass static functions in the
    automated prototype files, tfsproto.h and tftproto.h. For example:

    #if (TFS_FILENUM == TFS_CORE_C)
    static int TfsPrivateFunction(sTfsPrivateType *pType);
    #endif

---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
                              Revision History
    $Log: rlmods.h $
    Revision 1.1  2005/02/23 20:50:58  Pauli
    Initial revision
    Revision 1.1  2005/02/23 20:50:58Z  Garyp
    Initial revision
    Revision 1.1  2005/02/23 19:50:58Z  pauli
    Initial revision
    Revision 1.5  2005/02/23 18:50:57Z  brandont
    Added file number defines for the new modules and removed the ones 
    for the deleted modules.
    Revision 1.4  2004/12/31 01:17:53Z  GaryP
    Updated to use indents of 4, hard tabs of 8 (if used), and a standard
    comment style.
    Revision 1.3  2004/12/07 23:43:26Z  brandont
    Added module number for rlcosign.c.
    Revision 1.2  2004/12/01 03:02:28Z  brandont
    Updated, organized, and renumber the list of module file numbers.
    Revision 1.1  2004/09/29 20:23:46Z  brandont
    Initial revision
    Revision 1.6  2004/08/27 00:35:40  brandont
    - IR ? *.* Changed header on all the source modules to the FlashFx style header
---------------------------------------------------------------------------*/

/*  ----------------------------------------
    file numbers used to aid automated prototyping
    ----------------------------------------
*/


/*  Reliance core source modules
*/
#define TFS_CORE_C      1
#define TFS_DIR_C       2
#define TFS_DIRLIB_C    3
#define TFS_FILE_C      4
#define TFS_IMAP_C      5
#define TFS_IMAPLIB_C   6
#define TFS_INDEX_C     7
#define TFS_INODE_C     8
#define TFS_INODELIB_C  9
#define TFS_META_C      10
#define TFS_METALIB_C   11
#define TFS_CACHE_C     12


/*  Common driver modules
*/
#define TFS_METACMN_C   50
#define TFS_INODCMN_C   51
#define TFS_IMAPCMN_C   52
#define TFS_VOLCMN_C    53
#define TFS_MASTCMN_C   54
#define TFS_DIRCMN_C    55


/*  Common source modules
*/
#define TFS_64BIT_C     100
#define TFS_ALLOC_C     101
#define TFS_ASSERT_C    102
#define TFS_ATOI_C      103
#define TFS_ATOL_C      104
#define TFS_CASECMP_C   105
#define TFS_CONOUT_C    106
#define TFS_DBGLOG_C    107
#define TFS_END_C       108
#define TFS_FNMTCH_C    109
#define TFS_LIB_C       110
#define TFS_LOG_C       111
#define TFS_LTOA_C      112
#define TFS_MEMCMP_C    113
#define TFS_MEMCPY_C    114
#define TFS_MEMMOV_C    115
#define TFS_MEMSET_C    116
#define TFS_MEMSET32_C  117
#define TFS_PRINTF_C    118
#define TFS_SIGN_C      119
#define TFS_SPRINTF_C   120
#define TFS_STRNCHR_C   121
#define TFS_STRCHR_C    122
#define TFS_STRCMPI_C   123
#define TFS_STRCMP_C    124
#define TFS_STRCPY_C    125
#define TFS_STRLEN_C    126
#define TFS_STRNCMP_C   127
#define TFS_STRNCPY_C   128
#define TFS_STRRCHR_C   129
#define TFU_CMDLN_C     130
#define TFS_DEBUG_C     131
#define TFS_LOGIND_C    132
#define TFS_LOGIO_C     133
#define TFS_CLOCK_C     134
#define TFS_COSIGN_C    135
#define TFS_CRC32_C     136
#define TFS_VERCHK_C    137
#define TFS_RLEXTAPI_C  138
#define TFS_RLCHKSUM_C  139


/*  Tool source modules
*/
#define TFS_CHECK_C     200
#define TFS_CHKL_C      201
#define TFS_FORMAT_C    202
#define TFS_IMAGE_C     203
#define TFS_LIST_C      204
#define TFS_MUNGE_C     205
#define TFS_SCAN_C      206
#define TFS_SYS_C       207
#define TFS_SYSCMN_C    208
#define TFS_EXTENT_C    209
#define TFU_RPTCK_C     210
#define TFU_IMAGE_C     211
#define TFU_CHECK_C     212
#define TFU_FORMAT_C    213
#define TFU_MUNGE_C     214


/*  Test suite source modules
*/
#define TFT_CHECK_C     300
#define TFT_CMD_C       301
#define TFT_CORE2_C     302
#define TFT_CORE_C      303
#define TFT_CRASH_C     304
#define TFT_FILL_C      305
#define TFT_FRAG_C      306
#define TFT_INTERNAL_C  307
#define TFT_KILL_C      308
#define TFT_LARGE_C     309
#define TFT_TLIB_C      310
#define TFU_TEST_C      311
#define TFT_PERF_C      312
#define TFT_RANDOM_C    313
#define TFT_LOG_C       314
#define TFT_STUB_C      315
#define TFT_TEST2_C     316
#define TFT_TEST_C      317


/*  OS Integration Layer (OIL) source modules
*/
#define TFO_CON_C       400
#define TFO_LOG_C       401
#define TFO_IO_C        402
#define TFO_CLIB_C      403
#define TFO_DOS_C       404
#define TFO_OS_C        405
#define TFO_TASK_C      406
#define TFO_NFILE_C     407
#define TFO_ECACHE_C    408
#define TFO_ECLIB_C     409
#define TFO_EDOS_C      410
#define TFO_EIO_C       411
#define TFO_ELOG_C      412
#define TFO_EOS_C       413
#define TFO_ETASK_C     414
#define TFO_EFILE_C     415
#define TFO_ICACHE_C    416
#define TFO_ICLIB_C     417
#define TFO_IDOS_C      418
#define TFO_IIO_C       419
#define TFO_ILOG_C      420
#define TFO_IOS_C       421
#define TFO_ITASK_C     422
#define TFO_IFILE_C     423
#define TFO_RAND_C      424
#define TFO_STR_C       425
#define TFO_FORMAT_C    426
#define TFO_CHECK_C     427
#define TFO_TIME_C      428
#define TFO_NDIR_C      429
#define TFO_LIB_C       430
#define TFO_DRIVER_C    431
