/*---------------------------------------------------------------------------
               ----> DO NOT REMOVE THE FOLLOWING NOTICE <----

      Copyright (c) 2003 - 2004 Datalight, Inc.  All Rights Reserved.

  Datalight, Incorporated is a Washington State corporation located at:

        21520 30th Dr SE, Suite 110,      Tel:  425-951-8086
        Bothell, WA  98021                Fax:  425-951-8094
        USA                               Http://www.datalight.com

  This software, including without limitation, all source code and documen-
  tation, is the confidential, trade secret property of Datalight, Inc., and
  is protected under the copyright laws of the United States and other juris-
  dictions.

  ---> Portions of the software are patent pending <---

  In addition to civil penalties for infringement of copyright under applic-
  able U.S. law, 17 U.S.C. 1204 provides criminal penalties for violation of
  (a) the restrictions on circumvention of copyright protection systems found
  in 17 U.S.C. 1201 and (b) the protections for the integrity of copyright
  management information found in 17 U.S.C. 1202.

  U.S. Government Restricted Rights:  Use, duplication, reproduction, or
  transfer of this commercial product and accompanying documentation is
  restricted in accordance with FAR 12.212 and DFARS 227.7202 and by a
  License Agreement.

  IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS PROTECTED UNDER A
  SOURCE CODE AGREEMENT, NON-DISCLOSURE AGREEMENT (NDA), OR SIMILAR BINDING
  CONTRACT BETWEEN DATALIGHT, INC. AND THE LICENSEE ("BINDING AGREEMENT").
  YOUR RIGHT, IF ANY, TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,
  IS SUBJECT TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT.  BY USING
  THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE TO BE BOUND BY
  THE TERMS OF THE BINDING AGREEMENT.  CONTACT DATALIGHT, INC. AT THE ADDRESS
  SET FORTH ABOVE IF YOU OBTAINED THIS SOFTWARE IN ERROR.
---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
                              Description

    Native file/directory functions. Used by code that needs to access the
    native file system, not the TFS file system. For example, logging to an
    FAT32 volume when running tests on a TFS volume. Uses ANSI or POSIX
    functions where possible.

---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
                              Revision History
    $Log: rlnativ.h $
    Revision 1.1  2004/12/31 03:17:54  Pauli
    Initial revision
    Revision 1.1  2004/12/31 03:17:54Z  Garyp
    Initial revision
    Revision 1.1  2004/12/31 02:17:54Z  pauli
    Initial revision
    Revision 1.2  2004/12/31 01:17:53Z  GaryP
    Updated to use indents of 4, hard tabs of 8 (if used), and a standard
    comment style.
    Revision 1.1  2004/09/23 00:48:58Z  brandont
    Initial revision
    Revision 1.2  2004/08/27 00:34:58  brandont
    - IR ? *.* Changed header on all the source modules to the FlashFx style header
---------------------------------------------------------------------------*/

/*  native file functions 
*/
#define TfsNativeFSeek     fseek
#define TfsNativeFTell     ftell
#define TfsNativeFClose    fclose
#if TFS_UNICODE
#define TfsNativeVPrintf   _vtprintf
#define TfsNativeVFPrintf  _vftprintf
#define TfsNativeFOpen     _tfopen
#define TfsNativeRemove    _tremove
#define TfsNativeRename    _trename
#else
#define TfsNativeVPrintf   vprintf
#define TfsNativeVFPrintf  vfprintf
#define TfsNativeFOpen     fopen
#define TfsNativeRemove    remove
#define TfsNativeRename    rename
#endif


/*  native directory functions 
*/
#if defined(BCC)
#include <dir.h>                /* getcwd prototypes */
#define TfsGetCwd    _tgetcwd   /* posix 1003.1 */
#elif defined(MSVC)
#include <tchar.h>
#include <direct.h>             /* where to find getcwd prototypes */
#define TfsGetCwd    _tgetcwd   /* posix 1003.1 */
#elif defined(GCC)
#include <unistd.h>             /* getcwd prototype */
#define TfsGetCwd    getcwd     /* posix 1003.1 */
#endif
