/*---------------------------------------------------------------------------
               ----> DO NOT REMOVE THE FOLLOWING NOTICE <----

      Copyright (c) 2003 - 2005 Datalight, Inc.  All Rights Reserved.

  Datalight, Incorporated is a Washington State corporation located at:

        21520 30th Dr SE, Suite 110,      Tel:  425-951-8086
        Bothell, WA  98021                Fax:  425-951-8094
        USA                               Http://www.datalight.com

  This software, including without limitation, all source code and documen-
  tation, is the confidential, trade secret property of Datalight, Inc., and
  is protected under the copyright laws of the United States and other juris-
  dictions.

  ---> Portions of the software are patent pending <---

  In addition to civil penalties for infringement of copyright under applic-
  able U.S. law, 17 U.S.C. 1204 provides criminal penalties for violation of
  (a) the restrictions on circumvention of copyright protection systems found
  in 17 U.S.C. 1201 and (b) the protections for the integrity of copyright
  management information found in 17 U.S.C. 1202.

  U.S. Government Restricted Rights:  Use, duplication, reproduction, or
  transfer of this commercial product and accompanying documentation is
  restricted in accordance with FAR 12.212 and DFARS 227.7202 and by a
  License Agreement.

  IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS PROTECTED UNDER A
  SOURCE CODE AGREEMENT, NON-DISCLOSURE AGREEMENT (NDA), OR SIMILAR BINDING
  CONTRACT BETWEEN DATALIGHT, INC. AND THE LICENSEE ("BINDING AGREEMENT").
  YOUR RIGHT, IF ANY, TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,
  IS SUBJECT TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT.  BY USING
  THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE TO BE BOUND BY
  THE TERMS OF THE BINDING AGREEMENT.  CONTACT DATALIGHT, INC. AT THE ADDRESS
  SET FORTH ABOVE IF YOU OBTAINED THIS SOFTWARE IN ERROR.
---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
                              Description
---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
                              Revision History
    $Log: rlprof.h $
    Revision 1.1  2005/06/16 00:09:02  Pauli
    Initial revision
    Revision 1.2  2005/06/16 01:09:01Z  Pauli
    Merge with 2.0 product line, build 458.
    Revision 1.2  2005/06/16 01:09:01Z  brandont
    Added RelProfDump prototype.
    Revision 1.1  2005/05/27 23:01:02Z  brandont
    Initial revision
---------------------------------------------------------------------------*/

#ifndef _RLPROF_H
#define _RLPROF_H   1


/*  Make sure that TFS_PROFILER_ENABLED is defined
*/
#ifndef TFS_PROFILER_ENABLED
#define TFS_PROFILER_ENABLED        0
#endif


/*  Define the prototypes for the perf functions or macros to hide them.
*/
#if TFS_PROFILER_ENABLED
void RelProfEnter(tfsChar * szLabel, void * pUniqueAddress);
void RelProfLeave(tfsChar * szLabel, void * pUniqueAddress);
void RelProfEnable( void );
void RelProfDisable( void );
void RelProfDump( tfsChar * szPath );
#else
#define RelProfEnter( _szLabel, _pUniqueAddress )
#define RelProfLeave( _szLabel, _pUniqueAddress )
#define RelProfEnable()
#define RelProfDisable()
#define RelProfDump( _szPath )
#endif


#endif /* #ifndef _RLPROF_H */
