/*---------------------------------------------------------------------------
               ----> DO NOT REMOVE THE FOLLOWING NOTICE <----

      Copyright (c) 2003 - 2004 Datalight, Inc.  All Rights Reserved.

  Datalight, Incorporated is a Washington State corporation located at:

        21520 30th Dr SE, Suite 110,      Tel:  425-951-8086
        Bothell, WA  98021                Fax:  425-951-8094
        USA                               Http://www.datalight.com

  This software, including without limitation, all source code and documen-
  tation, is the confidential, trade secret property of Datalight, Inc., and
  is protected under the copyright laws of the United States and other juris-
  dictions.

  ---> Portions of the software are patent pending <---

  In addition to civil penalties for infringement of copyright under applic-
  able U.S. law, 17 U.S.C. 1204 provides criminal penalties for violation of
  (a) the restrictions on circumvention of copyright protection systems found
  in 17 U.S.C. 1201 and (b) the protections for the integrity of copyright
  management information found in 17 U.S.C. 1202.

  U.S. Government Restricted Rights:  Use, duplication, reproduction, or
  transfer of this commercial product and accompanying documentation is
  restricted in accordance with FAR 12.212 and DFARS 227.7202 and by a
  License Agreement.

  IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS PROTECTED UNDER A
  SOURCE CODE AGREEMENT, NON-DISCLOSURE AGREEMENT (NDA), OR SIMILAR BINDING
  CONTRACT BETWEEN DATALIGHT, INC. AND THE LICENSEE ("BINDING AGREEMENT").
  YOUR RIGHT, IF ANY, TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,
  IS SUBJECT TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT.  BY USING
  THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE TO BE BOUND BY
  THE TERMS OF THE BINDING AGREEMENT.  CONTACT DATALIGHT, INC. AT THE ADDRESS
  SET FORTH ABOVE IF YOU OBTAINED THIS SOFTWARE IN ERROR.
---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
                              Description

---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
                              Revision History
    $Log: rlstring.h $
    Revision 1.2  2006/02/22 19:21:22  Pauli
    Added const to input parameters.
    Revision 1.1  2005/12/02 22:13:34Z  Pauli
    Initial revision
    Revision 1.2  2005/12/02 22:13:34Z  Pauli
    Merge with 2.0 product line, build 458.
    Revision 1.4  2005/09/09 20:29:13Z  brandont
    Added prototype for _RelStrCat.
    Revision 1.3  2005/08/11 21:03:47Z  jeremys
    Added prototypes for atoi, atol, and ltoa.
    Revision 1.2  2004/12/31 01:17:53Z  GaryP
    Updated to use indents of 4, hard tabs of 8 (if used), and a standard
    comment style.
    Revision 1.1  2004/11/17 02:24:42Z  brandont
    Initial revision
---------------------------------------------------------------------------*/

#ifndef RLSTRING_H
#define RLSTRING_H   1


void            _RelMemMove(void *pDst, const void *pSrc, tfsUint32 iLength);
void            RelMemSet32(tfsUint32 * pBuffer, tfsUint32 iValue, tfsUint32 iNumWords);
int             _RelStrLen(const tfsChar * szStr);
void            _RelStrCat(tfsChar * szDst, const tfsChar * szSrc);
void            _RelStrCpy(tfsChar * szDst, const tfsChar * szSrc);
void            _RelStrNCpy(tfsChar * szDst, const tfsChar * szSrc, tfsUint32 iLen);
tfsChar        *_RelStrChr(const tfsChar * sz, tfsChar c);
tfsChar        *_RelStrRChr(const tfsChar * sz, tfsChar c);
tfsChar        *RelStrNChr(const tfsChar * psz, tfsChar c, int iLen);
int             _RelStrCmp(const tfsChar * szThis, const tfsChar * szThat);
int             _RelStrNCmp(const tfsChar * szThis, const tfsChar * szThat, int iLen);
int             _RelStrICmp(const tfsChar * szThis, const tfsChar * szThat);
int             _RelAtoI(const tfsChar * szStr);
long            _RelAtoL(const tfsChar * szStr);
int             _RelLtoA(tfsChar * pBuffer, tfsUint32 ulNum, tfsUint16 nRadix, int nBuffSize, tfsChar cFill);

#endif /* #ifndef RLSTRING_H */
