/*---------------------------------------------------------------------------
               ----> DO NOT REMOVE THE FOLLOWING NOTICE <----

      Copyright (c) 2003 - 2004 Datalight, Inc.  All Rights Reserved.

  Datalight, Incorporated is a Washington State corporation located at:

        21520 30th Dr SE, Suite 110,      Tel:  425-951-8086
        Bothell, WA  98021                Fax:  425-951-8094
        USA                               Http://www.datalight.com

  This software, including without limitation, all source code and documen-
  tation, is the confidential, trade secret property of Datalight, Inc., and
  is protected under the copyright laws of the United States and other juris-
  dictions.

  ---> Portions of the software are patent pending <---

  In addition to civil penalties for infringement of copyright under applic-
  able U.S. law, 17 U.S.C. 1204 provides criminal penalties for violation of
  (a) the restrictions on circumvention of copyright protection systems found
  in 17 U.S.C. 1201 and (b) the protections for the integrity of copyright
  management information found in 17 U.S.C. 1202.

  U.S. Government Restricted Rights:  Use, duplication, reproduction, or
  transfer of this commercial product and accompanying documentation is
  restricted in accordance with FAR 12.212 and DFARS 227.7202 and by a
  License Agreement.

  IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS PROTECTED UNDER A
  SOURCE CODE AGREEMENT, NON-DISCLOSURE AGREEMENT (NDA), OR SIMILAR BINDING
  CONTRACT BETWEEN DATALIGHT, INC. AND THE LICENSEE ("BINDING AGREEMENT").
  YOUR RIGHT, IF ANY, TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,
  IS SUBJECT TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT.  BY USING
  THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE TO BE BOUND BY
  THE TERMS OF THE BINDING AGREEMENT.  CONTACT DATALIGHT, INC. AT THE ADDRESS
  SET FORTH ABOVE IF YOU OBTAINED THIS SOFTWARE IN ERROR.
---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
                              Description
---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
                              Revision History
    $Log: rltproto.h $
    Revision 1.7  2006/03/29 22:05:04  brandont
    Added conditioned feature to look up a path based on an INode index.
    Revision 1.6  2006/03/01 20:37:07Z  joshuab
    Changed prototype of TfsPerfFileResult to take char instead of
    tfsChar.
    Revision 1.5  2006/02/01 20:12:22Z  Pauli
    Added prototype for TfsTLibRand to replace RelOsRand.
    Revision 1.4  2005/12/27 23:49:21Z  Pauli
    Removed prototypes for 64-bit math and endian tests that have
    been moved to DCL.
    Revision 1.3  2005/12/09 00:41:14Z  pauli
    Removed TfsTestCoreNameExtTranslation.
    Revision 1.2  2005/12/09 00:18:56Z  pauli
    Updated prototypes.
    Revision 1.1  2005/08/17 23:31:44Z  Pauli
    Initial revision
    Revision 1.2  2005/08/18 00:31:44Z  Pauli
    Merge with 2.0 product line, build 458.
    Revision 1.9  2005/08/18 00:31:44Z  brandont
    Revision 1.8  2005/08/12 20:25:50Z  brandont
    Added a prototype for TfsTestCoreVolumeLabel.
    Revision 1.7  2005/08/11 00:27:01Z  brandont
    Removed prototype for obsolete test category.
    Revision 1.6  2005/08/09 22:10:07Z  brandont
    Updated prototype for TfsTestRemoveInitialState.
    Revision 1.5  2005/08/01 23:41:14Z  brandont
    Added rlcorapi.h include until we get the header file factoring done.
    Revision 1.4  2005/02/23 19:11:54Z  brandont
    Removed buffer module function prototype.
    Revision 1.3  2004/12/31 01:17:53Z  GaryP
    Updated to use indents of 4, hard tabs of 8 (if used), and a standard
    comment style.
    Revision 1.2  2004/11/18 17:53:13Z  PaulI
    Added common test suite prototype.
    Revision 1.1  2004/09/23 00:50:52Z  brandont
    Initial revision
    Revision 1.15  2004/08/27 00:32:52  brandont
    - IR ? *.* Changed header on all the source modules to the FlashFx style header
---------------------------------------------------------------------------*/

#include <rlcorapi.h>

/*  test suite entry point
*/
int             TfsUtilityTest(int argc,tfsChar * argv[]);

/*  tftcheck.c
*/
void            TfsTestCheckNow(void);
void            TfsTestCheckTest1(void);
void            TfsTestCheckTest2(void);
void            TfsTestCheckTest3(void);
void            TfsTestCheckTest4(void);
void            TfsTestCheckCategory(void);

/*  tftcmd.c
*/
int             TfsInteractiveOpenFile(tfsChar * szFileName, int *piHandle, tfsBool fCreate);
int             TfsInteractiveCloseFile(int iHandle);
tfsChar        *TfsInteractiveSkipWhite(tfsChar * szArg);
tfsChar        *TfsInteractiveEndArg(tfsChar * szArg);
tfsChar        *TfsInteractiveNextArg(tfsChar * szArg);
tfsChar        *TfsInteractiveNullTerminate(tfsChar * szArg);
void           *TfsInteractiveAllocMemory(tfsOffset * piLength);
void            TfsInteractiveFillPattern(tfsChar * szFileName, tfsOffset iOffset, void *pBuffer, tfsOffset iBuffLength);
int             TfsInteractiveReadWrite(int iHandle, tfsOffset iOffset, tfsOffset iLength, tfsBool fWrite, tfsBool fFrag);
int             TfsTestInteractive(tfsChar * pszFileName);

/*  tftcore.c
*/
void            TfsTestCoreCategory(void);
void            TfsTestCoreMkdir(void);
void            TfsTestCoreRemdir(void);
void            TfsTestCoreOpendir(void);
void            TfsTestCoreReaddir(void);
void            TfsTestCoreRewind(void);
int             TfsTestCoreCountEntries(sTfsOpenDir * pDir);
void            TfsTestCoreFind(void);
void            TfsTestCoreClosedir(void);
void            TfsTestCoreGetVolInfo(void);
void            TfsTestCoreFill(void);
void            TfsTestCoreIoctl(void);

/*  tftcore2.c
*/
void            TfsTestCoreAttr(void);
void            TfsTestCoreCreateFile(void);
void            TfsTestCoreDeleteFile(void);
void            TfsTestCoreOpenFile(void);
void            TfsTestCoreCloseFile(void);
void            TfsTestCoreExist(void);
void            TfsTestCoreRename(void);
void            TfsTestCoreAddHardLink(void);
void            TfsTestCoreReadFile(void);
void            TfsTestCoreWriteFile(void);
void            TfsTestCoreReadWrite(int iTran);
void            TfsTestCoreTruncate(void);
void            TfsTestCoreVolumeLabel(void);
#if REL_FEATURE_REVERSE_LOOKUP
void            TfsTestCoreHandleToPath(void);
#endif
void            TfsTestCoreAttributes(void);
void            TfsTestCoreValidCharacters(void);
void            TfsTestCoreNamePathLength(void);
void            TfsTestCoreSpecialNames(void);
void            TfsTestCoreNameCase(void);
void            TfsTestCoreFileSize(void);
void            TfsTestCoreNameTranslation(void);
void            TfsTestCoreTransaction(void);

/*  tftfill.c
*/
void            TfsTestFillCategory(void);
#if TFS_FILENUM == TFT_FILL_C
static void     TfsTestEmptyFilledDirectory(tfsChar * szBuffer, tfsChar * szDir, tfsUint32 iCount, eTfsTestDirection eEmptyOrder);
#endif
void            TfsTestFillWithDirs(tfsChar * szDir, tfsUint32 iMaxDirs);
void            TfsTestFillDirectoryDeep(void);
void            TfsTestFillDirectory(tfsChar * szTestDir, tfsUint32 iMaxDirs);
void            TfsTestFillRootDir(tfsUint32 iMaxDirs);
int             TfsTestFillWithFiles(tfsChar * szTestDir, tfsUint32 iMaxFileCount, tfsOffset iFileSize);

/*  tftfrag.c
*/
void            TfsTestFragCategory(void);
int             TfsTestFragFixed(tfsChar * szDir, tfsUint32 iNumHoles, tfsUint32 iHoleSize);
int             TfsTestFragRandom(tfsChar * szDir, tfsUint32 iNumHoles, tfsUint32 iMinHoleSize, tfsUint32 iMaxHoleSize);
int             TfsTestFragCheckFunctionality(tfsChar * szDir, tfsUint32 iNumHoles);
int             TfsTestFragInitialize(tfsChar * szDir, tfsUint32 iNumHoles, tfsUint32 iMinHoleBlocks, tfsUint32 iMaxHoleBlocks);
int             TfsTestFragCleanUp(tfsChar * szDir);

/*  tftinter.c
*/
void            TfsTestStructureSizes(void);
void            TfsTestFormatVolumes(void);
void            TfsTestCreateVolume(void);
void            TfsTestReFormat(tfsBlock * piBadBlocks);
void            TfsTestReMount(void);
int             TfsTestCreateOrMountVolume(void);
void            TfsTestBadBlocks(void);
void            TfsTestDiscard(void);
void            TfsTestINodeCountContiguous(void);
void            TfsTestINodeCoordSeek(void);
void            TfsTestLibraryFunctions(void);
#if TFS_FILENUM == TFT_INTERNAL_C
static void     TfsTestWildPattern(sTfsWildTest * pWildTest);
#endif
void            TfsTestWildCards(void);
void            TfsTestFnMatch(void);
void            TfsTestCmdLine(void);
void            TfsTestInternalFunctions(void);
void            TfsTestInternalCategory(void);

/*  tftkill.c
*/
void            TfsTestKillPoint(void);
void            TfsTestKillRandom(void);
void            TfsTestKillBlock(void);
void            TfsTestKillCategory(void);

/*  tftlarge.c
*/
void            TfsTestLargeFileCategory(void);
int             TfsTLibLargeMakeFileName(tfsChar * szPath, tfsChar * szDir, tfsUint32 iFileNum, tfsChar * szExt);
tfsChar       **TfsTestLargeCreateFileNameArray(tfsChar * szDir, tfsUint32 iNumFiles, tfsChar * szExt);
int             TfsTestLargeFreeFileNameArray(tfsChar ** ppPathArray);
void            TfsTestInitializeRecordSizeArray(void);
int             TfsTestLargeDetermineFileSize(tfsUint32 iNumFiles, tfsOffset * piFileSize, tfsUint32 * piRecordSize);
int             TfsTestSingleLargeFile(tfsChar * szDir, tfsOffset iFileSize, tfsUint32 iRecordSize);
int             TfsTestMultipleLargeFiles(tfsChar * szDir, tfsUint32 iNumFiles, tfsOffset iFileSize, tfsUint32 iRecordSize);

/*  tftlib.c
*/
void            TfsTLibAnnounceDataBase(tfsChar * szMsg, sTfsTestDataBase * pDataBase,  tfsBool fVerboseOnly);
int             TfsTLibCreateDataBase(sTfsTestDataBase * pDataBase, tfsChar * szPath, eTfsTestDirection iDirection, tfsOffset iFileSize, tfsOffset iRecordSize);
int             TfsTLibDeleteDataBase(sTfsTestDataBase * pDataBase);
int             TfsTLibCloseDataBase(sTfsTestDataBase * pDataBase);
void            TfsTLibCreateRecord(tfsByte * pbBuffer, sTfsTestDataBase * pDataBase);
void            TfsTLibRewindDataBase(sTfsTestDataBase * pDataBase);
int             TfsTLibGetNextRecordNumber(sTfsTestDataBase * pDataBase);
int             TfsTLibWriteFirstRecord(sTfsTestDataBase * pDataBase, void *pBuffer);
int             TfsTLibWriteNextRecord(sTfsTestDataBase * pDataBase, void *pBuffer);
int             TfsTLibVerifyFirstRecord(sTfsTestDataBase * pDataBase, void *pBuffer, void *pBuffer2);
int             TfsTLibVerifyNextRecord(sTfsTestDataBase * pDataBase, void *pBuffer, void *pBuffer2);
int             TfsTLibWriteDataBase(sTfsTestDataBase * pDataBase, void *pBuffer);
int             TfsTLibVerifyDataBase(sTfsTestDataBase * pDataBase, void *pBuffer, void *pBuffer2);
int             TfsTLibVerifyPartialDataBase(sTfsTestDataBase * pDataBase, tfsOffset iStartRecord, tfsOffset iNumRecords, void *pBuffer, void *pBuffer2);
tfsUint32       TfsTLibSRand(tfsUint32 iSeed);
tfsUint32       TfsTLibRand(tfsUint32 iLimit);
void           *TfsTLibAlloc(tfsUint32 iNumBytes);
void            TfsTLibCreateTestPattern(tfsBuffer * pbBuffer, tfsUint32 iBuffSize, tfsChar * szFileName, tfsUint32 iBlockNumber);
void            TfsTLibCreateTestBlockPattern(tfsBuffer * pbBuffer, tfsOffset iNumBlocks, tfsOffset iBlockSize, tfsChar * szFileName, tfsUint32 iBlockNumber);
void            TfsTLibGetPathLimits(void);
tfsUint32       TfsTLibCountEntriesInOpenDir(TFSDIR * pDir);
tfsUint32       TfsTLibCountDirEntries(tfsChar * szDir);
tfsChar        *TfsTLibGetDirectionString(eTfsTestDirection eTestDirection);
tfsBlock        TfsTLibGetFreeBlocks(void);
tfsUint32       TfsTLibGetBlockSize(void);
tfsBlock        TfsTLibMaxBlocksPerRecord(tfsUint32 iRecordSize);
tfsBlock        TfsTLibMinBlocksPerRecord(tfsUint32 iRecordSize);
tfsChar        *TfsTLibAllocPath(tfsChar * szPath);
int             TfsTLibDeleteFiles(tfsChar * szPath, tfsChar * szMask);
int             TfsTLibDeleteAllFiles(tfsChar * szDir);
int             TfsTLibCreateFile(tfsChar * szFileName, tfsOffset iFileSize, tfsOffset iRecordSize);

/*  tftperf.c
*/
void            TfsTestPerfCategory(void);
void            TfsPerfTestRaw(tfsBlock iStart, tfsBlock iLength, tfsBlock iChunkSize);
void            TfsPerfTestWrite(tfsChar * szFileName, tfsOffset iLength, tfsOffset iChunkSize, tfsBool fVerify);
int             TfsPerfWrite(tfsChar * szFileName, tfsOffset iLength, tfsOffset iChunkSize);
void            TfsPerfTestRead(tfsChar * szFileName, tfsOffset iLength, tfsOffset iChunkSize);
int             TfsPerfRead(tfsChar * szFileName, tfsOffset iLength, tfsOffset iChunkSize);
void            TfsPerfTestRand(tfsChar * szFileName, tfsOffset iLength, tfsOffset iChunkSize, tfsBool fVerify, tfsUint32 iSeed);
void            TfsPerfTestDir(int iLevels, int iEntries);
void            TfsPerfTestOps(int iLevels, int iEntries, tfsOffset iLength);
int             TfsPerfRecurseFileOp(tfsUint32 iFunction, int iLevel, tfsChar * szPath, tfsChar * szLevel, tfsChar * szName, int iLevels, int iEntries, tfsOffset iLength);
tfsChar        *TfsPerfFileArgs(tfsChar * szFileName, tfsOffset * piLength, tfsOffset * piChunkSize);
void            TfsPerfInitBuf(void *pBuf, tfsOffset iBufSize, tfsUint32 iFill);
void            TfsPerfFileResult(int fHeader, char * szTestName, tfsUint32 iLength, tfsOffset iChunkSize, tfsUint32 iTime);
void            TfsLogResults(tfsChar * szFmt, ...);

/*  tftrand.c
*/
int             TfsTestRandomCategory(void);
int             TfsTestRandomFileIO(tfsChar * szTestRoot, tfsOffset iMaxFileSize, tfsUint32 iMaxFileCount, tfsUint32 iMaxDirCount, tfsUint32 iRunTime, tfsUint32 iSeed);
#if TFS_FILENUM == TFT_RANDOM_C
static int      TfsTestRandPerformFileOp(sTfsRandFileList * pFileList, sTfsRandDirList * pDirList);
#endif
#if TFS_FILENUM == TFT_RANDOM_C
static int      TfsTestRandPerformDirOp(sTfsRandDirList * pDirList);
#endif
#if TFS_FILENUM == TFT_RANDOM_C
static tfsUint32 TfsTestRandCreateUniqueFileName(sTfsRandFileList * pFileList, tfsChar * szName);
#endif
#if TFS_FILENUM == TFT_RANDOM_C
static tfsUint32 TfsTestRandCreateUniqueDirName(sTfsRandDirList * pDirList, tfsChar * szName);
#endif
int             TfsRandMakeDirName(tfsChar * szName, tfsUint32 iDirNum);
#if TFS_FILENUM == TFT_RANDOM_C
static int      TfsTestRandBuildPathFromFile(tfsChar * szPath, sTfsRandFile * pFile);
#endif
#if TFS_FILENUM == TFT_RANDOM_C
static int      TfsTestRandBuildPath(tfsChar * szPath, int iBufferLen, sTfsRandDir * pDir, tfsChar * szName);
#endif
#if TFS_FILENUM == TFT_RANDOM_C
static void     TfsTestRandInitializeDirEntry(sTfsRandDir * pDir, tfsBlock iDirNum, sTfsRandDir * pDirParent);
#endif
#if TFS_FILENUM == TFT_RANDOM_C
static sTfsRandFile *TfsTestRandSelectFile(sTfsRandFileList * pFileList);
#endif
#if TFS_FILENUM == TFT_RANDOM_C
static sTfsRandDir *TfsTestRandSelectDirectory(sTfsRandDirList * pDirList, tfsBool fIncludeRoot);
#endif
#if TFS_FILENUM == TFT_RANDOM_C
static sTfsRandDir *TfsTestRandFindDir(sTfsRandDirList * pDirList, tfsBlock iDirNum);
#endif
#if TFS_FILENUM == TFT_RANDOM_C
static sTfsRandFile *TfsTestRandFindFile(sTfsRandFileList * pFileList, tfsBlock iFileNum);
#endif
#if TFS_FILENUM == TFT_RANDOM_C
static int      TfsTestRandCreateFile(sTfsRandFileList * pFileList, sTfsRandDirList * pDirList, sTfsRandFile ** ppFile);
#endif
#if TFS_FILENUM == TFT_RANDOM_C
static int      TfsTestRandOpenFile(sTfsRandFile * pFile);
#endif
#if TFS_FILENUM == TFT_RANDOM_C
static int      TfsTestRandCloseFile(sTfsRandFile * pFile);
#endif
#if TFS_FILENUM == TFT_RANDOM_C
static int      TfsTestRandRenameFile(sTfsRandFile * pFile);
#endif
#if TFS_FILENUM == TFT_RANDOM_C
static int      TfsTestRandDeleteFile(sTfsRandFile * pFile);
#endif
#if TFS_FILENUM == TFT_RANDOM_C
static int      TfsTestRandWriteToFile(sTfsRandFile * pFile);
#endif
#if TFS_FILENUM == TFT_RANDOM_C
static int      TfsTestRandReadFromFile(sTfsRandFile * pFile);
#endif
#if TFS_FILENUM == TFT_RANDOM_C
static int      TfsTestRandTruncateFile(sTfsRandFile * pFile);
#endif
#if TFS_FILENUM == TFT_RANDOM_C
static int      TfsTestRandCreateDirectory(sTfsRandDirList * pDirList, sTfsRandDir ** ppDir);
#endif
#if TFS_FILENUM == TFT_RANDOM_C
static int      TfsTestRandOpenDir(sTfsRandDir * pDir);
#endif
#if TFS_FILENUM == TFT_RANDOM_C
static int      TfsTestRandCloseDir(sTfsRandDir * pDir);
#endif
#if TFS_FILENUM == TFT_RANDOM_C
static int      TfsTestRandDeleteDir(sTfsRandDir * pDir);
#endif
#if TFS_FILENUM == TFT_RANDOM_C
static int      TfsTestRandReadDir(sTfsRandDir * pDir);
#endif
#if TFS_FILENUM == TFT_RANDOM_C
static int      TfsTestRandRenameDirectory(sTfsRandDir * pDir);
#endif
#if TFS_FILENUM == TFT_RANDOM_C
static void     TfsTestRandomInitSelectionLookupTables(void);
#endif
#if TFS_FILENUM == TFT_RANDOM_C
static int      TfsTestRandFreeFileList(sTfsRandFileList * pFileList);
#endif
#if TFS_FILENUM == TFT_RANDOM_C
static int      TfsTestRandFreeDirList(sTfsRandDirList * pDirList);
#endif
#if TFS_FILENUM == TFT_RANDOM_C
static int      TfsTestRandClearSpace(sTfsRandFileList * pFileList, tfsBlock iFreeBlockTarget);
#endif

/*  tftstub.c
*/
int             TfsTestCreateOrMountVolume(void);
void            TfsTestInternalCategory(void);
void            TfsTestCoreCategory(void);
void            TfsTestCheckCategory(void);
void            TfsTestCheckNow(void);

/*  tfttest.c
*/
void            TfsTestBasicCategory(void);
void            TfsTestBasicTransaction(void);
void            TfsTestBasicFileOps(void);
void            TfsTestBasicSubdirectories(void);
void            TfsTestBasicOpenDirectory(void);
void            TfsTestBasicMultiVolume(void);
void            TfsTestTypeCategory(void);
void            TfsTestTypeSize(void);


/*  tfttest2.c
*/
tfsChar        *TfsTestMakeName(tfsChar * szOrgName, int iNumber);
tfsChar        *TfsTestEndString(tfsChar * szStr);
int             TfsTestCreateInitialState(sTfsTestInitState * pState);
int             TfsTestRemoveInitialState(sTfsTestInitState * pInitState, tfsBool fIgnoreErrors );
void            TfsTestOpenDirHelper(tfsChar * szDir, int iWantCount);
tfsUint32       TfsTestCheckMaxLevels(tfsUint32 iMaxPathLen, tfsChar * szName);
void            TfsTestRecurseMakeDirectory(int iLevel, tfsChar * szPath, tfsChar * szLevel, tfsChar * szName, int iTfsMaxLevel, int iTfsNumDirs);
void            TfsTestRecurseRemoveDirectory(int iLevel, tfsChar * szPath, tfsChar * szLevel, tfsChar * szName, int iTfsMaxLevel, int iTfsNumDirs);

/*  tftuser.c
*/
void            TfsTestUserCategory(void);

