/*---------------------------------------------------------------------------
               ----> DO NOT REMOVE THE FOLLOWING NOTICE <----

      Copyright (c) 2003 - 2005 Datalight, Inc.  All Rights Reserved.

  Datalight, Incorporated is a Washington State corporation located at:

        21520 30th Dr SE, Suite 110,      Tel:  425-951-8086
        Bothell, WA  98021                Fax:  425-951-8094
        USA                               Http://www.datalight.com

  This software, including without limitation, all source code and documen-
  tation, is the confidential, trade secret property of Datalight, Inc., and
  is protected under the copyright laws of the United States and other juris-
  dictions.

  ---> Portions of the software are patent pending <---

  In addition to civil penalties for infringement of copyright under applic-
  able U.S. law, 17 U.S.C. 1204 provides criminal penalties for violation of
  (a) the restrictions on circumvention of copyright protection systems found
  in 17 U.S.C. 1201 and (b) the protections for the integrity of copyright
  management information found in 17 U.S.C. 1202.

  U.S. Government Restricted Rights:  Use, duplication, reproduction, or
  transfer of this commercial product and accompanying documentation is
  restricted in accordance with FAR 12.212 and DFARS 227.7202 and by a
  License Agreement.

  IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS PROTECTED UNDER A
  SOURCE CODE AGREEMENT, NON-DISCLOSURE AGREEMENT (NDA), OR SIMILAR BINDING
  CONTRACT BETWEEN DATALIGHT, INC. AND THE LICENSEE ("BINDING AGREEMENT").
  YOUR RIGHT, IF ANY, TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,
  IS SUBJECT TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT.  BY USING
  THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE TO BE BOUND BY
  THE TERMS OF THE BINDING AGREEMENT.  CONTACT DATALIGHT, INC. AT THE ADDRESS
  SET FORTH ABOVE IF YOU OBTAINED THIS SOFTWARE IN ERROR.
---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
                              Description
---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
                              Revision History
    $Log: rltrace2.h $
    Revision 1.1  2005/06/03 19:43:30  Pauli
    Initial revision
    Revision 1.1  2005/06/03 20:43:30Z  Garyp
    Initial revision
    Revision 1.1  2005/06/03 20:43:30Z  pauli
    Initial revision
    Revision 1.2  2005/06/03 20:43:29Z  brandont
    Updated the defines for determining whether this header file has 
    already been included with the updated name of the source file.
    Revision 1.1  2005/06/01 20:45:28Z  brandont
    Initial revision
---------------------------------------------------------------------------*/

#ifndef _RLTRACE2_H
#define _RLTRACE2_H   1


/*  Make sure that TFS_TRACE_ENABLED is defined
*/
#ifndef TFS_TRACE_ENABLED
#define TFS_TRACE_ENABLED           0
#endif
#ifndef TFS_TRACE_LOG
#define TFS_TRACE_LOG               "host:c:/trace.log"
#endif


/*  Define the prototypes for the trace functions or macros to hide them.
*/
#if TFS_TRACE_ENABLED
void RelTraceEnter(tfsChar * szLabel, void * pUniqueAddress);
void RelTraceLeave(tfsChar * szLabel, void * pUniqueAddress);
void RelTraceEnable( void );
void RelTraceDisable( void );
#else
#define RelTraceEnter( _szLabel, _pUniqueAddress )
#define RelTraceLeave( _szLabel, _pUniqueAddress )
#define RelTraceEnable()
#define RelTraceDisable()
#endif


#endif /* #ifndef _RLTRACE2_H */
