/* semLib.h - semaphore library header file */

/* Copyright 1984-2004 Wind River Systems, Inc. */

/*
modification history
--------------------
04m,26oct04,fr   added semOpenInit() routine (SPR 101491)
04l,08mar04,aeg  removed Diab _WRS_DEPRECATED C++ workaround.
04k,02mar04,aeg  deprecated semOLib APIs.
04j,25nov03,aeg  added semInfo() function prototype from semLibCommon.h.
04i,21aug03,dcc  moved common definitions with user side to semLibCommon.h.
04h,20jun03,ymz  updated year of copyright.
04g,14mar03,dcc  moved SEM_ID definition to types/vxWind.h.
04f,19oct01,bwa  Added SEM_EVENTSEND_ERR_NOTIFY option.
04e,16feb98,cdp  added #ifndef _ASMLANGUAGE.
04d,10jul96,dbt  added declaration of semMGiveForce (SPR #4352).
		 Updated copyright.
03c,14jul94,dvs  added non-ANSI prototype for semCreate/semOLibInit (SPR# 2648).
03b,22sep92,rrr  added support for c++.
03a,04jul92,jcf  cleaned up.
02k,26may92,rrr  the tree shuffle.
02j,18apr92,jmm  added prototype for semTerminate.
02i,19nov91,rrr  shut up some ansi warnings.
02h,04oct91,rrr  passed through the ansification filter
		  -fixed #else and #endif
		  -changed ASMLANGUAGE to _ASMLANGUAGE
		  -changed copyright notice
02g,10jun91.del  added pragma for gnu960 alignment.
02f,16oct90,shl  made #else ANSI style.
02e,05oct90,dnw  deleted private functions; doc tweaks
02d,05oct90,shl  added ANSI function prototypes.
                 made #endif ANSI style.
                 added copyright notice.
02c,27jun90,jcf  added defines for optimized version.
02a,26jun90,jcf  rewritten to provide binary/counting/mutex w/ one structure.
		 introduced semaphore options.
		 removed generic status codes.
01a,02jan90,jcf  written.
*/

#ifndef __INCsemLibh
#define __INCsemLibh

#ifdef __cplusplus
extern "C" {
#endif

#include "vxWorks.h"
#include "vwModNum.h"
#include "semLibCommon.h"


/* semaphore options */

#define SEM_Q_MASK		 0x03	/* q-type mask */

#ifndef	_ASMLANGUAGE

/* function declarations */

extern STATUS 	semBLibInit 	(void);
extern STATUS 	semCLibInit 	(void);
extern STATUS 	semMLibInit 	(void);
extern void	semOpenInit	(void);
extern STATUS   semMGiveForce 	(SEM_ID semId);

/* workaround Diab handling of deprecated attribute in C++ */

extern STATUS 	semOLibInit 	(void) _WRS_DEPRECATED ("please use semBLib instead");
extern SEM_ID 	semCreate 	(void) _WRS_DEPRECATED ("please use semBLib instead");
extern void 	semShowInit 	(void);
extern STATUS 	semShow 	(SEM_ID semId, int level);
extern int      semInfo         (SEM_ID semId, int idList[], int maxTasks);

#endif	/* _ASMLANGUAGE */

#ifdef __cplusplus
}
#endif

#endif /* __INCsemLibh */
