/* semaphoreCommon.h - POSIX usr/kernel shared semaphore header file */

/* Copyright 2003 Wind River Systems, Inc. */

/*
modification history
--------------------
01b,18nov03,m_s  code-inspection changes
01a,31oct03,m_s  Written
*/

#ifndef __INCsemaphoreCommonh
#define __INCsemaphoreCommonh

#ifdef __cplusplus
extern "C" {
#endif

/* includes */

#include "fcntl.h"
#include "limits.h"

/* defines */

#define SEM_VALUE_MAX 100 	/* maximum value to initialize a semaphore */
#define SEM_NSEMS_MAX 100 	/* maximum number of semaphores in the system */

#define SEM_FAILED    ((sem_t *) ERROR)   /* failure for sem_open */

#undef _POSIX_NO_TRUNC		/* do not limit pathname length */

/* typedefs */

/* function declarations */

extern int      sem_init     (sem_t *, int, unsigned int);
extern int      sem_destroy  (sem_t *);
extern sem_t *  sem_open     (const char *, int, ...);
extern int      sem_close    (sem_t *);
extern int      sem_unlink   (const char *);
extern int      sem_wait     (sem_t *);
extern int      sem_trywait  (sem_t *);
extern int      sem_post     (sem_t *);
extern int      sem_getvalue (sem_t *, int *);


#ifdef __cplusplus
}
#endif

#endif /* __INCsemaphoreCommonh */
