/* distNameLib.h - distributed name database header (VxFusion) */

/*
 * Copyright (c) 1997-1999, 2005 Wind River Systems, Inc.
 *
 * The right to copy, distribute, modify or otherwise make use
 * of this software may be licensed only pursuant to the terms
 * of an applicable Wind River license agreement.
 */

/*
modification history
--------------------
01d,21apr05,ebh  adding _WRS_DEPRECATED macro to all prototypes
01c,24may99,drm  adding vxfusion prefix to VxFusion related includes
01b,12aug98,drm  removed #include of private file
01a,10jun97,ur   written.
*/

#ifndef __INCdistNameLibh
#define __INCdistNameLibh

#include "vxWorks.h"
#include "vwModNum.h"
#include "vxfusion/distLib.h"

#ifdef __cplusplus
extern "C" {
#endif

/* defines */

#define T_DIST_MSG_Q	DIST_OBJ_TYPE_MSG_Q  /* message queue */
#define T_DIST_NODE		16                   /* node identifier */
#define T_DIST_UINT8	64                   /* 8 bit integer */
#define T_DIST_UINT16	65                   /* 16 bit integer */
#define T_DIST_UINT32	66                   /* 32 bit integer */
#define T_DIST_UINT64	67                   /* 64 bit integer */
#define T_DIST_FLOAT	68                   /* float */
#define T_DIST_DOUBLE	69                   /* double */

#define S_distNameLib_NAME_TOO_LONG		(M_distNameLib | 1)  /* error code */
#define S_distNameLib_ILLEGAL_LENGTH	(M_distNameLib | 2)  /* error code */
#define S_distNameLib_INVALID_WAIT_TYPE	(M_distNameLib | 3)  /* error code */
#define S_distNameLib_DATABASE_FULL		(M_distNameLib | 4)  /* error code */
#define S_distNameLib_INCORRECT_LENGTH	(M_distNameLib | 5)  /* error code */

/* typedefs */

typedef uint16_t DIST_NAME_TYPE;		/* type of object assoc. with name */

/* function declarations */

#if defined(__STDC__) || defined(__cplusplus)

void	distNameLibInit (void)
	_WRS_DEPRECATED ("vxFusion End of Life is fall 2005");
STATUS	distNameInit (int sizeLog2)
	_WRS_DEPRECATED ("vxFusion End of Life is fall 2005");
STATUS	distNameAdd (char *name, void *value, int len, DIST_NAME_TYPE type)
	_WRS_DEPRECATED ("vxFusion End of Life is fall 2005");
STATUS	distNameFind (char *name, void **pValue, DIST_NAME_TYPE *pType,
				int waitType)
	_WRS_DEPRECATED ("vxFusion End of Life is fall 2005");
STATUS	distNameFindByValueAndType (void *value, DIST_NAME_TYPE pType,
				char *name, int waitType)
	_WRS_DEPRECATED ("vxFusion End of Life is fall 2005");
STATUS	distNameRemove (char *name)
	_WRS_DEPRECATED ("vxFusion End of Life is fall 2005");
void	distNameShow (void)
	_WRS_DEPRECATED ("vxFusion End of Life is fall 2005");
void	distNameFilterShow (DIST_NAME_TYPE type)
	_WRS_DEPRECATED ("vxFusion End of Life is fall 2005");

#else	/* __STDC__ */

void	distNameLibInit ()
	_WRS_DEPRECATED ("vxFusion End of Life is fall 2005");
STATUS	distNameInit ()
	_WRS_DEPRECATED ("vxFusion End of Life is fall 2005");
STATUS	distNameAdd ()
	_WRS_DEPRECATED ("vxFusion End of Life is fall 2005");
STATUS	distNameFind ()
	_WRS_DEPRECATED ("vxFusion End of Life is fall 2005");
STATUS	distNameFindByValueAndType ()
	_WRS_DEPRECATED ("vxFusion End of Life is fall 2005");
STATUS	distNameRemove ()
	_WRS_DEPRECATED ("vxFusion End of Life is fall 2005");
void	distNameShow ()
	_WRS_DEPRECATED ("vxFusion End of Life is fall 2005");
void	distNameFilterShow ()
	_WRS_DEPRECATED ("vxFusion End of Life is fall 2005");

#endif	/* __STDC__ */

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __INCdistNameLibh */

