/* distNetLib.h - distribted objects network layer header file (VxFusion) */

/*
 * Copyright (c) 1998-1999, 2005 Wind River Systems, Inc.
 *
 * The right to copy, distribute, modify or otherwise make use
 * of this software may be licensed only pursuant to the terms
 * of an applicable Wind River license agreement.
 */

/*
modification history
--------------------
01d,21apr05,ebh  adding _WRS_DEPRECATED macro to all prototypes
01c,24may99,drm  adding vxfusion prefix to VxFusion related includes
01b,22feb99,drm  added distNetInput()
01a,10nov98,drm  written.
*/

#ifndef __INCdistNetLibh
#define __INCdistNetLibh

#ifdef __cplusplus
extern "C" {
#endif

/* includes */

#include "vxWorks.h"
#include "vxfusion/distLib.h"
#include "vxfusion/distNodeLib.h"
#include "vxfusion/distTBufLib.h"

/* defines */

#define DIST_CTL_TYPE_NET       DIST_ID_NET_LIB
#define DIST_CTL_SERVICE_HOOK   ((0 << 8) | DIST_CTL_TYPE_NET)
#define DIST_CTL_SERVICE_CONF   ((1 << 8) | DIST_CTL_TYPE_NET)

/* typedefs */

typedef struct  /* DIST_SERV_CONF */
    {
    int     servId;     /* ID of service to configure */
    int     taskPrio;   /* priority of service task */
    int     netPrio;    /* network priority of service */
    } DIST_SERV_CONF;

/* function declarations */

#if defined(__STDC__) || defined(__cplusplus)

void    distNetInput (DIST_NODE_ID nodeIdIn, int prioIn, DIST_TBUF *pTBufIn)
	_WRS_DEPRECATED ("vxFusion End of Life is fall 2005");

#else   /* __STDC__ */

void    distNetInput ()
	_WRS_DEPRECATED ("vxFusion End of Life is fall 2005");

#endif /* __STDC__ */

#ifdef __cplusplus
}
#endif

#endif  /* __INCdistNetLibh */

