/* distNetLibP.h - distributed objects network layer private header (VxFusion)*/

/*
 * Copyright (c) 1997-1999, 2005 Wind River Systems, Inc.
 *
 * The right to copy, distribute, modify or otherwise make use
 * of this software may be licensed only pursuant to the terms
 * of an applicable Wind River license agreement.
 */

/*
modification history
--------------------
01d,21apr05,ebh  adding _WRS_DEPRECATED macro to all prototypes
01c,24may99,drm  added vxfusion to VxFusion related includes
01b,10nov98,drm  moved net-related distCtl() parameters to public .h file
01a,17jul97,ur   written.
*/

#ifndef __INCdistNetLibPh
#define __INCdistNetLibPh

#ifdef __cplusplus
extern "C" {
#endif

#include "vxWorks.h"
#include "vxfusion/distLib.h"
#include "vxfusion/distTBufLib.h"
#include "vxfusion/distNetLib.h"
#include "vxfusion/private/distNodeLibP.h"
#include "vxfusion/private/distPktLibP.h"

/* defines */

#define DIST_SERV_MAX			16

#define DIST_NET_SERV_INST(servId)	(servTable[(servId)].servTaskId)

/* typedefs */

typedef struct							/* DIST_IOVEC */
	{
	void	*pIOBuffer;
	UINT	IOLen;
	} DIST_IOVEC;

typedef struct							/* DIST_SERV_NODE */
	{
	SEMAPHORE		servWait4Jobs;
	SEMAPHORE		servQLock;
	int				servId;
	BOOL			servUp;
	DIST_TBUF_HDR	*pServQ;
	int				servTaskId;
	int				servTaskPrio;
	int				servNetPrio;
	} DIST_SERV_NODE;

typedef int	DIST_STATUS;				/* DIST_STATUS */

typedef DIST_STATUS (* DIST_SERV_FUNC) (DIST_NODE_ID, DIST_TBUF_HDR *);

/* extern */

extern DIST_SERV_NODE servTable[];

/* function declarations */

#if defined(__STDC__) || defined(__cplusplus)

void	distNetInit (void)
	_WRS_DEPRECATED ("vxFusion End of Life is fall 2005");
int		distNetCtl (int function, int argument)
	_WRS_DEPRECATED ("vxFusion End of Life is fall 2005");
STATUS	distNetServAdd (int servId, DIST_SERV_FUNC servInput,
			char *servTaskName, int servNetPrio, int servTaskPrio,
			int servTaskStackSz)
	_WRS_DEPRECATED ("vxFusion End of Life is fall 2005");
STATUS	distNetServConfig (int servId, int taskPrio, int netPrio)
	_WRS_DEPRECATED ("vxFusion End of Life is fall 2005");
STATUS	distNetServUp (int servId)
	_WRS_DEPRECATED ("vxFusion End of Life is fall 2005");
STATUS	distNetServDown (int servId)
	_WRS_DEPRECATED ("vxFusion End of Life is fall 2005");
STATUS	distNetSend (DIST_NODE_ID nodeId, DIST_PKT *pPkt, UINT size,
			int timo, int prio)
	_WRS_DEPRECATED ("vxFusion End of Life is fall 2005");
STATUS	distNetIOVSend (DIST_NODE_ID nodeId, DIST_IOVEC *iov, int num,
			int timo, int prio)
	_WRS_DEPRECATED ("vxFusion End of Life is fall 2005");

#else	/* __STDC__ */

void	distNetInit ()
	_WRS_DEPRECATED ("vxFusion End of Life is fall 2005");
int	distNetCtl ()
	_WRS_DEPRECATED ("vxFusion End of Life is fall 2005");
STATUS	distNetServAdd ()
	_WRS_DEPRECATED ("vxFusion End of Life is fall 2005");
STATUS	distNetServConfig ()
	_WRS_DEPRECATED ("vxFusion End of Life is fall 2005");
STATUS	distNetServUp ()
	_WRS_DEPRECATED ("vxFusion End of Life is fall 2005");
STATUS	distNetServDown ()
	_WRS_DEPRECATED ("vxFusion End of Life is fall 2005");
STATUS	distNetSend ()
	_WRS_DEPRECATED ("vxFusion End of Life is fall 2005");
STATUS	distNetIOVSend ()
	_WRS_DEPRECATED ("vxFusion End of Life is fall 2005");

#endif	/* __STDC__ */

#ifdef __cplusplus
}
#endif

#endif  /* __INCdistNetLibPh */

