/* wait.h - wait facility library header */

/* Copyright 1984-2003 Wind River Systems, Inc. */

/*
modification history
--------------------
01c,27aug04,md   fixed WIFSIGNALED() macro
01b,26nov03,nrj  added function prototype
01a,28oct03,nrj  written from posix spec
*/

#ifndef __INCwaith
#define __INCwaith

#ifdef __cplusplus
extern "C" {
#endif

#define WNOHANG			0x01

/* not supported, for compatibility */
#define WUNTRACED		0x02

#define	WIFEXITED(status)	((int)((status) & 0xFF00) == 0)
#define	WIFSIGNALED(status)	((int)((status) & 0xFF00) != 0)
#define	WIFSTOPPED(status)	((int)((status) & 0xFF0000) != 0)
#define	WEXITSTATUS(status)	((int)((status) & 0xFF))
#define	WTERMSIG(status)	((int)(((status) >> 8) & 0xFF))
#define	WSTOPSIG(status)	((int)(((status) >> 16) & 0xFF))

/* Only include while building kernel */

#ifdef _WRS_KERNEL

#define	SET_EXITSTATUS(status)	((int)((status)&0xFF))
#define	SET_TERMSIG(sig)	((int)(((sig)<<8)&0xFF00))
#define	SET_STOPSIG(sig)	((int)(((sig)<<16)&0xFF0000))

#endif

extern RTP_ID wait(int *);
extern RTP_ID waitpid(RTP_ID, int *, int);

#ifdef __cplusplus
}
#endif

#endif /* __INCwaith */
