/* dhcp6Lib.h - header file for DHCPv6 related definitions */

/* Copyright 2004 Wind River Systems, Inc. */
#include "copyright_wrs.h"

/*
modification history
--------------------
01c,10aug04,syy  Code review changes
01b,01jul04,syy  Add prevention of multiple inclusion
01a,24jun04,syy  Written
*/

#ifndef __INCdhcp6Libh
#define __INCdhcp6Libh

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

struct dhcp6sInitParams {
    u_int  ramDiskSize;
    u_int  downStreamPort;
    u_int  upStreamPort;
    u_int  priority;   
    u_int  dhcp6sSize;
    };

struct dhcp6cInitParams {
    char   *uplinkIfName;
    char   *downlinkIfName;
    u_int   downStreamPort;
    u_int   upStreamPort;
    u_int   priority;
    u_int   dhcp6cSize;
    };

struct dhcp6rInitParams {
    char  *srcAddr;
    char  *servAddr;
    char  *uIfName;
    u_int  hopLimit;
    u_int  downStreamPort;
    u_int  upStreamPort;
    u_int  priority;
    u_int  dhcp6rSize;
    };

typedef enum {DNS_LIST=0, NTP_LIST, DNS_NAME_LIST, PREFIX_LIST} dh6InfoType_t;
    
/* function prototypes */
extern STATUS dhcp6c __P((char *ifname, int option, int debug_level));
extern STATUS dhcp6cStop __P((void));

extern STATUS dhcp6s __P((char *confFileName, /* configuration file name */
                          char  *ifName,      /* interface to monitor */
                          u_int  debugLevel   /* verbosity */
                        ));
extern STATUS dhcp6sStop __P((void));

extern STATUS dhcp6relay __P((char *ifName,   /* interface name to client link */
                              u_int debugLevel/* 0: silent; 1: verbose; 2: more
                                                 verbose */
                             ));
extern STATUS dhcp6rStop __P((void));

extern int dh6cInfoGet (dh6InfoType_t, char **, int, int);
    
#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* ! __INCdhcp6Libh */
