/* logCategories.h */

/* Copyright 2004 Wind River Systems, Inc. */

/*
modification history
--------------------
01b,28oct04,ann  changed default log level for FTP client to 0 (SPR# 103249)
01a,07sep04,dlk  written
*/

/*
 * This header file forms the database of logging facilities used
 * by applLogLib and syslog.h. It is meant to be included multiple
 * times, with varying definitions of the LOG_DB() and LOG_DB_LAST()
 * macros, so it is not protected against multiple inclusion.
 *
 *                      Default   Default
 *      Facility        Dest. FD  Logging Decoration and Level
 *      --------        --------  ------------------------------
 */

LOG_DB (RIPNG,		STD_OUT,  (_LOG_DEC_DFLT | _LOG_LVL_DFLT))
LOG_DB (PING_V4,	STD_OUT,  (_LOG_DEC_DFLT | _LOG_LVL_DFLT))
LOG_DB (PING_V6,	STD_OUT,  (_LOG_DEC_DFLT | _LOG_LVL_DFLT))
LOG_DB (TELNET,		STD_OUT,  (_LOG_DEC_DFLT | _LOG_LVL_DFLT))
LOG_DB (TELNETD,	STD_OUT,  (_LOG_DEC_DFLT | _LOG_LVL_DFLT))
LOG_DB (TFTP,		STD_OUT,  (_LOG_DEC_DFLT | _LOG_LVL_DFLT))
LOG_DB (TFTPD,		STD_OUT,  (_LOG_DEC_DFLT | _LOG_LVL_DFLT))
LOG_DB (FTP,		STD_OUT,  (_LOG_DEC_DFLT |       0      ))
LOG_DB (FTPD,		STD_OUT,  (_LOG_DEC_DFLT | _LOG_LVL_DFLT))
LOG_DB (DHCP_V4,	STD_OUT,  (_LOG_DEC_DFLT | _LOG_LVL_DFLT))
LOG_DB (DHCPD_V4,	STD_OUT,  (_LOG_DEC_DFLT | _LOG_LVL_DFLT))
LOG_DB (DHCP_V6,	STD_OUT,  (_LOG_DEC_DFLT | _LOG_LVL_DFLT))
LOG_DB (DHCPD_V6,	STD_OUT,  (_LOG_DEC_DFLT | _LOG_LVL_DFLT))
LOG_DB (DNS,		STD_OUT,  (_LOG_DEC_DFLT | _LOG_LVL_DFLT))
LOG_DB (SYSCTL,		STD_OUT,  (_LOG_DEC_DFLT | _LOG_LVL_DFLT))
LOG_DB (RIP_V4,		STD_OUT,  (_LOG_DEC_DFLT | _LOG_LVL_DFLT))
LOG_DB (RTADV,		STD_OUT,  (_LOG_DEC_DFLT | _LOG_LVL_DFLT))
LOG_DB (RTSOL,		STD_OUT,  (_LOG_DEC_DFLT | _LOG_LVL_DFLT))
LOG_DB (NATPT,		STD_OUT,  (_LOG_DEC_DFLT | _LOG_LVL_DFLT))
LOG_DB (RDISC,		STD_OUT,  (_LOG_DEC_DFLT | _LOG_LVL_DFLT))
LOG_DB (RLOGIN,		STD_OUT,  (_LOG_DEC_DFLT | _LOG_LVL_DFLT))
LOG_DB (REMLIB,		STD_OUT,  (_LOG_DEC_DFLT | _LOG_LVL_DFLT))
LOG_DB (KERN,		KERN_LOG_FD,  (_LOG_DEC_DFLT | _LOG_LVL_DFLT))
LOG_DB (NETDRV,		STD_OUT,  (_LOG_DEC_DFLT | _LOG_LVL_DFLT))

/* must be last */
LOG_DB_LAST (GENERAL,	STD_OUT,  (_LOG_DEC_DFLT | _LOG_LVL_DFLT))

