/* vsMld.h - virtual stack data for MLD6 */

/* Copyright 2000 - 2002 Wind River Systems, Inc. */

/*
modification history
--------------------
01e,10nov03,rlm  2nd pass of include update for header re-org.
01d,05nov03,cdw  Removal of unnecessary _KERNEL guards.
01c,04nov03,rlm  Ran batch header path update for header re-org.
01b,28aug02,kal  fixed ml6_var.h location
01a,27aug02,kal  created
*/

#ifndef __INCvsMldh
#define __INCvsMldh


/* includes */

#include <netinet/in.h>
#include <netinet/in_var.h>
#include <netinet6/ip6.h>
#include <netinet6/ip6_var.h>
#include <protos/mld6_var.h>

/* defines */

/* typedefs */

typedef struct vs_mld
    {

    /* From mld6.c */

    struct mld6QuerierHead      _mld6Querier;
    BOOL                        mld6Enabled;
    
    struct ip6_pktopts          priv_ip6_opts;
    int                         priv_mld6_timers_are_running;

    struct in6_addr             priv_mld6_all_nodes_linklocal;
    struct in6_addr             priv_mld6_all_routers_linklocal;

	u_int8_t                    priv_hbh_buf[8];

    } VS_MLD;

/* macros */

#define VS_MLD_DATA ((VS_MLD *)vsTbl[myStackNum]->pMldGlobals)

#define _mld6Querier     VS_MLD_DATA->_mld6Querier
#define mld6Enabled     VS_MLD_DATA->mld6Enabled

#endif /* __INCvsMldh */

